# Copyright 1999-2002 Gentoo Technologies, Inc.
# Distributed under the terms of the GNU General Public License v2
# $Header:

IUSE="alsa divx4linux ffmpeg"

DESCRIPTION="Descrambling plugin for xawdecode"
HOMEPAGE="http://cricrac.fr.st"
SRC_URI="http://cricrac.fr.st/download/xawdecode/beta/${P}.tar.gz"

SLOT="0"
LICENSE="GPL-2"
KEYWORDS="~x86"

DEPEND="virtual/x11
   >=media-tv/xawdecode-1.6.5
   divx4linux ( >=media-libs/divx4linux-20030428 )
   alsa? ( media-libs/alsa-lib media-sound/alsa-utils )
   ffmpeg ( >=media-video/ffmpeg-0.4.6 )"

src_compile() {
   local myconf="-with-xawdecode-prefix=/usr --enable-all-filters"

   use alsa \
      && myconf="${myconf} --enable-alsa" \
      || myconf="${myconf} --disable-alsa"

   use divx4linux \
      && myconf="${myconf} --enable-divx4linux" \
      || myconf="${myconf} --disable-divx4linux"

   use ffmpeg \
      && myconf="${myconf} --enable-ffmpeg" \
      || myconf="${myconf} --disable-ffmpeg"
      
   econf ${myconf} || die "Configuration failed."

   emake CFLAGS="${CFLAGS}" || die "Compilation failed."
   # Or should we keep the optimized flags they suggest?
   #emake || die "Compilation failed."
}

src_install() {

   einstall || die "Installation failed."

   dodoc AUTHORS INSTALL COPYING ChangeLog
   dodoc xawdecoderc.sample lircrc.*.sample
   dodoc FAQfr-xawdecode-plugin Readme.txt
   
}
