
/*********************************************************************************
 *                                                                               *
 * MeuhMeuhPlug.cpp                                                              *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 

//////////////////////////////////////////////////////////////////////////////////
// MeuhMeuhPlug 1.3.5.1 is a plugin for K!TV 1.2.x.x  &  XawDecode !!           //
//////////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <stdio.h>
#include "Structures.h"

#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------

#include "resource.h"
#include "../pluginvideo.h" 
#include "../../ReadWriteINI/readwriteini.h"	// Cricri : use K!TV file
//#include "../readwriteini.h"					// NiKral
#include "HtmlHelp\HtmlHelp.h"
#include "MMPlugCapture\Capture.h"		// NiKral
#include "MMPlugParam\AjustParamDlg.h"
//--- Windows Section (END) ------------------------------------------------------
#else
//--- Linux Section (BEGIN) ------------------------------------------------------

#include <sys/stat.h>
#include <sys/types.h>
#include "pluginvideo.h" 
#include "AjustParamDlg.h"
#include "Capture.h"
//--- Linux Section (END) --------------------------------------------------------
#endif

#include "LaVache.h" 

#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------
//AccTable
ACCEL AccTable[] = {
	{FVIRTKEY|FCONTROL,	'K',	ID_SAVEIMAGE},			// CTRL K (debug)
	{FVIRTKEY|FCONTROL,	'L',	ID_LOADIMAGE},			// CTRL L (debug)
	{FVIRTKEY|FCONTROL,	'T',	ID_WAIT},				// CTRL T (debug)
	{FVIRTKEY		,	'P',	ID_MORE_PURPLE_LEV},	// P		NiKral 
	{FVIRTKEY		,	'L',	ID_LESS_PURPLE_LEV},	// L		NiKral
	{FVIRTKEY		,	'F',	ID_FILTER_SECAM},		// F 
	{FVIRTKEY|FCONTROL,	'F',	ID_FILTER_PURPLE},		// CTRL F
	{FVIRTKEY|FALT,		'F',	ID_FILTER_AVERAGE},		// ALT  F	cricri
	{FVIRTKEY|FCONTROL,	'I',	IDM_INFO_OSD_MM},		// CTRL I	NiKral
	{FVIRTKEY|FCONTROL,	'X',	ID_CAPTURE_ON},			// CTRL X	NiKral
	{FVIRTKEY|FCONTROL,	VK_F3,	IDM_PLUGIN_VIDEO_SETUP},// CTRL F3
	{FVIRTKEY|FCONTROL,	VK_F1,	IDM_HELP_PLUGIN},		// CTRL F1
};
//--- Windows Section (END) ------------------------------------------------------
#endif

QuenotteTV_VideoPlugin VideoPlugin;		//instance of KTV_VideoPlugin object

CLaVache *			pLaVache=NULL;			//class
CAjustParamDlg *	pAjustParamDlg=NULL;	//class

bool bLoadImage=false;
bool bSaveImage=false;
bool bCaptureOn=false;		// NiKral
//NiKral bool bDetectSignalOver=false;

bool bInitFile=false;
float fCpuUsed=0;
__int64 nReferTime=0;
int	nTestNormalUser=-1;
int nTestPreviousUser=-1;
bool bWait=false;
float fLevelSignalDetect=0;

float fGoodPhaseSecam=(float)0.35;
bool bSpinFilterSecam=true;

BOOL bFullField=TRUE;
BOOL bFilterSecam=TRUE;
BOOL bFilterPurple=FALSE;
BOOL bFilterAverage=FALSE;	// cricri

// NiKral
BOOL bFilterEMMX=FALSE;
BOOL bFilterSSE=FALSE;
char sCapFileName[MAX_PATH];
BOOL bCapCrypt=DEFAULT_CAP_CRYPT;
BOOL bCapHalfField=DEFAULT_CAP_HF;
BOOL bCapNoBlack=DEFAULT_CAP_NOBLACK;
int  nPurpleLevel=DEFAULTPURPLELEVEL;
static BOOL bLoadParams;

#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------

static HMENU hStdMenu = NULL;		// cricri
CRITICAL_SECTION PluginVideoCrit;	// Pour ne pas faire planter ... (ajout NiKral)
Capture *			pCapture=NULL;	// NiKral

char *NomFichierINI = "Plugins\\MeuhMeuhPlug.ini";	// NiKral

ConfigINI cfg[]= {
//	parameter				type			variable
	{"MeuhMeuhPLUG"         ,CFG_SECTION    ,NULL				},
	{"TEST_NORMAL_USER"     ,CFG_INT        ,&nTestNormalUser	},
	{"TEST_PREVIOUS_USER"   ,CFG_INT        ,&nTestPreviousUser	},
	{"FULLFIELD"            ,CFG_BOOL       ,&bFullField		},
	{"FILTER_SECAM"         ,CFG_BOOL       ,&bFilterSecam		},
	{"FILTER_PURPLE"        ,CFG_BOOL       ,&bFilterPurple		},
	{"FILTER_AVERAGE"       ,CFG_BOOL       ,&bFilterAverage	},
	{"FILTER_eMMX"          ,CFG_BOOL       ,&bFilterEMMX		},
	{"FILTER_SSE"           ,CFG_BOOL       ,&bFilterSSE		},
	{"PURPLE_LEVEL"         ,CFG_INT        ,&nPurpleLevel		},
	{"CAPTURE_FILENAME"     ,CFG_STRING     ,&sCapFileName		},
	{"CAPTURE_CRYPT"        ,CFG_BOOL       ,&bCapCrypt			},
	{"CAPTURE_HALF_FIELD"   ,CFG_BOOL       ,&bCapHalfField		},
	{"CAPTURE_NOBLACK"      ,CFG_BOOL       ,&bCapNoBlack		},
	{NULL, 0 ,NULL}
};

BOOL Start();
BOOL Stop();

void CheckStuff(void);	
void ShowDialog();
HMENU GetPluginMenu(BOOL ContextMenu);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
void CheckMenu(HMENU hMenu);

//--- Windows Section (END) ------------------------------------------------------
#else
//--- Linux Section (BEGIN) ------------------------------------------------------

char File_PossibleNormal[255];
char File_PossiblePrevious[255];
char File_LineNormal[255];
char File_LinePrevious[255];
char File_PurpleKey[255];
char File_ChromiKey[255];
char File_Capture[255];
char home_dir[255];

char *NomFichierINI = "MeuhMeuhPlug.ini";

struct {char *name;int *val;} cfg[] = {
  {"TEST_NORMAL_USER"     ,  &nTestNormalUser	},
  {"TEST_PREVIOUS_USER"   ,  &nTestPreviousUser	},
  {"FULLFIELD"            ,  &bFullField	},
  {"FILTER_SECAM"         ,  &bFilterSecam	},
  {"FILTER_PURPLE"        ,  &bFilterPurple	},
  {"FILTER_AVERAGE"       ,  &bFilterAverage	},
  {"FILTER_eMMX"          ,  &bFilterEMMX		},
  {"FILTER_SSE"           ,  &bFilterSSE	},
  {"PURPLE_LEVEL"         ,  &nPurpleLevel	},
  {"IS_BT878"             ,  &VideoPlugin.bIsBT878},
  {NULL, NULL}
};

static bool LoadParams(void);
static bool SaveParams(void);
static void DoFPC(void);

//--- Linux Section (END) --------------------------------------------------------
#endif

void InitStuff();
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);

void GetStatus(char * Text, BOOL Nb);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();
BOOL DetecteSignal(BYTE *VBI);

__int64 GetRDTSCTime();

inline int GetNbrOfMissingField(int nCurrentFrame, BOOL bIsOdd);      // cricri


#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------

//////////////////////////////////////////////////////////////////////////////////
// cricri : pour liberer la mmoire par appel des destructeurs
/* ------------------------------- Dll call -------------------------------- */
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
/* ------------------------------------------------------------------------- */
{
    switch ( ul_reason_for_call) {

		case DLL_PROCESS_ATTACH:
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
            
			//SaveParams
			if ( bLoadParams)
				SauverINI(cfg, NomFichierINI);

            if (pLaVache != NULL)
                delete pLaVache;
            pLaVache = NULL;

            if ( pAjustParamDlg != NULL)
                delete pAjustParamDlg;
            pAjustParamDlg = NULL;
			
			// NiKral
			if ( pCapture != NULL)
                delete pCapture;
            pCapture = NULL;

            break;
    }
    return TRUE;

	/* to avoid warning	*/
	UNREFERENCED_PARAMETER( hModule);
	UNREFERENCED_PARAMETER( lpReserved);
}


// init KTV_VideoPlugin instance
extern "C" __declspec( dllexport )QuenotteTV_VideoPlugin * GetVPlugin()
{
	//create class
	pLaVache = new CLaVache();
	if ( !pLaVache)
		return FALSE;

	pAjustParamDlg = new CAjustParamDlg();
	if ( !pAjustParamDlg)
		return FALSE;

	// NiKral
	pCapture = new Capture();
	if ( !pCapture)
		return FALSE;
	strcpy( sCapFileName, DEFAULT_FILENAME);
	
	bLoadParams = ChargerINI( cfg, NomFichierINI);	// NiKral

	//set plugin params
	VideoPlugin.version = VIDEO_PLUGIN_VERSION;
	VideoPlugin.description = DESCRIPTION;			// version (modif. NiKral)
	
	VideoPlugin.VIA_FIX = false;
	VideoPlugin.AutoProcessVideo = true;
	VideoPlugin.VIA_FIX_X = 638;	

	VideoPlugin.accel = AccTable;
	VideoPlugin.NbAccel = sizeof(AccTable)/sizeof(*AccTable);

	VideoPlugin.MovieBoost=0;
	VideoPlugin.FullField=bFullField;

	VideoPlugin.Start=Start;
	VideoPlugin.Stop=Stop;	

	VideoPlugin.InitStuff=InitStuff;
	VideoPlugin.DoStuff=DoStuff;
	VideoPlugin.CheckStuff=CheckStuff;

	VideoPlugin.ShowDialog=ShowDialog;
	VideoPlugin.GetPluginMenu=GetPluginMenu;	
	VideoPlugin.ProcessMessage=ProcessMessage;

	VideoPlugin.GetStatus=GetStatus;
	VideoPlugin.SetLow=SetLow;
	VideoPlugin.AutoMovieBoostFound=AutoMovieBoostFound;
	VideoPlugin.DetecteSignal=DetecteSignal;

	return &VideoPlugin;
}


BOOL Start()
{	
	InitializeCriticalSection(&PluginVideoCrit);
	
    if ( !bLoadParams)
	{
		bFilterPurple = VideoPlugin.bIsBT878;
		CheckMenu( hStdMenu);
	}

	pLaVache->Init();			//init LaVache variables
	if (!pLaVache->IsInit() || !bLoadParams)			// cricri
		ShowDialog();			//init failure  -> show params dialogue
	bLoadParams = TRUE;

	VideoPlugin.FullField = bFullField;				// Cricri

	pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
						bFilterSecam, bFilterPurple,bFilterAverage, \
						bFilterEMMX,bFilterSSE,nPurpleLevel);

	pCapture->SetParams(sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);	// NiKral

	// cricri : for safety
	for ( int j = 0; j < 5; j++) {
		pLaVache->DirectBufferCopy(VideoPlugin.OddLines[j],VideoPlugin.OutOddLines[j]);
		pLaVache->DirectBufferCopy(VideoPlugin.EvenLines[j],VideoPlugin.OutEvenLines[j]);
	}
	
	return TRUE;
}


BOOL Stop()
{
	EnterCriticalSection(&PluginVideoCrit);

	bFullField=VideoPlugin.FullField;

	pLaVache->Destroy();	//destroy LaVache variables

	fLevelSignalDetect=0;	//set off plugin

	LeaveCriticalSection(&PluginVideoCrit);
	DeleteCriticalSection(&PluginVideoCrit);

	return TRUE;
}

//--- Windows Section (END) ------------------------------------------------------
#else
//--- Linux Section (BEGIN) ------------------------------------------------------

extern "C"
{
	void meuhmeuh_reinit(void) { bInitFile=true;}
	
	int get_meuhmeuh_filtersecam(void) { return bFilterSecam;}
	
	void set_meuhmeuh_filtersecam(int value)
	{
		bFilterSecam=value;
		bInitFile=true;
	}
	
	int get_meuhmeuh_filterpurple(void) { return bFilterPurple;}
	
	void set_meuhmeuh_filterpurple(int value)
	{
		bFilterPurple=value;
		bInitFile=true;
	}
	
	int get_meuhmeuh_filteraverage(void) { return bFilterAverage;}

	void set_meuhmeuh_filteraverage(int value)
	{
		bFilterAverage=value;
		bInitFile=true;
	}

	int toggle_meuhmeuh_filtersecam(void)
	{
		bFilterSecam=!bFilterSecam;
		bInitFile=true;
		return bFilterSecam;
	}

	int toggle_meuhmeuh_filterpurple(void)
	{
		bFilterPurple=!bFilterPurple;
		bInitFile=true;
		return bFilterPurple;
	}

	int toggle_meuhmeuh_filteraverage(void)
	{
		bFilterAverage=!bFilterAverage;
		bInitFile=true;
		return bFilterAverage;
	}
}

// init. MeuhMeuhPlug for XawDecode
extern "C" QuenotteTV_VideoPlugin *init_mm_Plugin(char *user_dir)
{
	bool bInitOK=false;
	char m_dir[255];

	// Directories
	strcpy(m_dir,user_dir);
	strcpy(home_dir,user_dir);
	strcat(m_dir,"/");
	strcat(m_dir,PLUGIN_SUBDIR);

	strcpy(File_PossibleNormal,m_dir);
	strcat(File_PossibleNormal,"PossibleNormal.fpc");

	strcpy(File_PossiblePrevious,m_dir);
	strcat(File_PossiblePrevious,"PossiblePrevious.fpc");

	strcpy(File_LineNormal,m_dir);
	strcat(File_LineNormal,"LineNormal.fpc");

	strcpy(File_LinePrevious,m_dir);
	strcat(File_LinePrevious,"LinePrevious.fpc");

	strcpy(File_PurpleKey,m_dir);
	strcat(File_PurpleKey,"Purple.fpc");

	strcpy(File_ChromiKey,m_dir);
	strcat(File_ChromiKey,"Chromi.fpc");

	strcpy(File_Capture,"/tmp/CaptureMeuhMeuh.img");

	//create class
	pLaVache = new CLaVache();
	if ( !pLaVache)
		return FALSE;

	pAjustParamDlg = new CAjustParamDlg();
	if ( !pAjustParamDlg)
		return FALSE;

	//set plugin params
	VideoPlugin.version = VIDEO_PLUGIN_VERSION;
	VideoPlugin.description = DESCRIPTION;
	
	VideoPlugin.MovieBoost=0;
	VideoPlugin.FullField=bFullField;

	VideoPlugin.InitStuff=InitStuff;
	VideoPlugin.DoStuff=DoStuff;

	VideoPlugin.GetStatus=GetStatus;
	VideoPlugin.SetLow=SetLow;
	VideoPlugin.AutoMovieBoostFound=AutoMovieBoostFound;
	VideoPlugin.DetecteSignal=DetecteSignal;

	//load params
	bInitOK=LoadParams();
	if (!bInitOK)
	{
		SaveParams();
		bInitOK=LoadParams();
	}
	
	pLaVache->Init();               //init LaVache variables
	pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
						bFilterSecam, bFilterPurple,bFilterAverage, \
						bFilterEMMX,bFilterSSE,nPurpleLevel);
	
	bInitOK=pLaVache->IsInit();

	if (!bInitOK)
	{
		mkdir(home_dir,S_IRWXU);
		mkdir(m_dir,S_IRWXU);
		DoFPC();
	}

	nReferTime=GetRDTSCTime();

	return &VideoPlugin;
}

//--- Linux Section (END) --------------------------------------------------------
#endif

void InitStuff()
{	
	nReferTime=GetRDTSCTime();
}		


//main process 
void DoStuff(BOOL bIsOdd, BOOL *pbUpdateBuffer, BOOL *pbViewBuffer)
{	
	__int64 nTimeCurrent=GetRDTSCTime();
	__int64 nDeltaTime=nTimeCurrent-nReferTime;
	nReferTime=nTimeCurrent;

	int nCurrentFrame = VideoPlugin.CurrentFrame;
	int nPreviousFrame=nCurrentFrame-1;
	if (nPreviousFrame<0)
#ifndef MM_LINUX
		nPreviousFrame+=5;					//--- Windows Section
#else
		nPreviousFrame+=VideoPlugin.NbBuff;	//--- Linux Section
#endif
	*pbUpdateBuffer = *pbViewBuffer = FALSE;

	//set CurrentX param
	pLaVache->SetSizeBuffer(VideoPlugin.CurrentX,CURRENTY);
	pLaVache->SetHeightBlackBorder(VideoPlugin.MovieBoost);

	//must init LaVache variables (happen after AjustParamDlg)
	if (bInitFile)
	{
		bInitFile=false;
		pLaVache->Destroy();
		fLevelSignalDetect=0;	//set off plugin (NiKral)
		pLaVache->Init();
		pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
							bFilterSecam,bFilterPurple,bFilterAverage, \
							bFilterEMMX,bFilterSSE,nPurpleLevel);

#ifndef MM_LINUX	//--- Windows Section
		pCapture->SetParams(sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);
#endif
		return;
	}

	// LaVache not init ?
	if (!pLaVache->IsInit())
	{	//nothing to do
		if(bIsOdd)
			pLaVache->DirectBufferCopy(VideoPlugin.OddLines[nCurrentFrame],VideoPlugin.OutOddLines[nCurrentFrame]);
		else
			pLaVache->DirectBufferCopy(VideoPlugin.EvenLines[nCurrentFrame],VideoPlugin.OutEvenLines[nCurrentFrame]);

		*pbUpdateBuffer = TRUE;
		return;					//nothing to do
	}

	// LaVache is init!

    // cricri : use of CurrentFrame to detect missing fields, more accurate than timer
    if ( GetNbrOfMissingField( nCurrentFrame, bIsOdd)) {
		pLaVache->LossKeyRepeat();
        OutputDebugString( "missing frames by counter\n");
    }

	//Find key
	if ( VideoPlugin.FullField)	{
		//FullField  ----------------------
		if ( bIsOdd) {
			//save Image (debug)
			if (bSaveImage)
			{	
				bSaveImage=false;
				pLaVache->SaveImage( VideoPlugin.OddLines[nCurrentFrame],
									 VideoPlugin.EvenLines[nCurrentFrame]);
			}

			//odd frame
			if (pLaVache->FindKey( VideoPlugin.OddLines[nCurrentFrame],
								   VideoPlugin.OutOddLines[nCurrentFrame],
								   VideoPlugin.bIsBT878,
								   bIsOdd, bSpinFilterSecam)) {
				
				//key found -> be happy happy happy happy happy happy 
				fLevelSignalDetect = 1;	//key found -> SignalDetect

				//check phase (low pass filter)
				fGoodPhaseSecam = ( fGoodPhaseSecam * (float)5.0
									+ (float)(pLaVache->GetPhase() ^ bSpinFilterSecam))
									/ (float)6.0;
#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			} else if (*(VideoPlugin.OutEvenLines[nCurrentFrame])) {
				pLaVache->DirectBufferCopy( VideoPlugin.OutEvenLines[nCurrentFrame],
											VideoPlugin.OutOddLines[nCurrentFrame]);
#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			}

			//toggle SpinFilterSecam each image (2 frames)
			bSpinFilterSecam=!bSpinFilterSecam;

			//check Secam phase filter
			if ( fGoodPhaseSecam < 0.25) {
				fGoodPhaseSecam = 1.0;
				bSpinFilterSecam = !bSpinFilterSecam;		//toggle secam phase filter 
			}
#ifdef MM_LINUX
				*pbViewBuffer = TRUE;
#endif
		} else {		
			//Even frame
			if ( pLaVache->FindKey( VideoPlugin.EvenLines[nCurrentFrame],
									VideoPlugin.OutEvenLines[nCurrentFrame],
									VideoPlugin.bIsBT878,
									bIsOdd, !bSpinFilterSecam)) {				
				//key found -> be happy happy happy happy happy happy 
#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			} else if ( *(VideoPlugin.OutOddLines[nPreviousFrame])) {
				pLaVache->DirectBufferCopy( VideoPlugin.OutOddLines[nPreviousFrame],
											VideoPlugin.OutEvenLines[nCurrentFrame]);
#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			}			
		}
	} else {
		//HalfField  ----------------------
		if ( !bIsOdd) {		// cricri

			//toggle SpinFilterSecam each image 
			bSpinFilterSecam = !bSpinFilterSecam;

			//use EvenLines but K!TV send bIsOdd
			//bug -> send (!bIsOdd) to LaVache
			if ( pLaVache->FindKey( VideoPlugin.EvenLines[nCurrentFrame],
									VideoPlugin.OutEvenLines[nCurrentFrame],
									VideoPlugin.bIsBT878,
									bIsOdd, bSpinFilterSecam)) {

                //key found -> be happy happy happy happy happy happy 
				fLevelSignalDetect = 1;	//key found -> SignalDetect
				
				//check phase (low pass filter)
				fGoodPhaseSecam = ( fGoodPhaseSecam * (float)5.0
									+ (float)(pLaVache->GetPhase() ^ bSpinFilterSecam))
									/ (float)6.0;

#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			} else if ( *(VideoPlugin.OutEvenLines[nPreviousFrame])) {
				pLaVache->DirectBufferCopy( VideoPlugin.OutEvenLines[nPreviousFrame],
											VideoPlugin.OutEvenLines[nCurrentFrame]);
#ifdef MM_LINUX
				*pbUpdateBuffer = TRUE;
#endif
			}


			//check Secam phase filter
			if ( fGoodPhaseSecam < 0.25) {
				fGoodPhaseSecam = 1.0;
				bSpinFilterSecam = !bSpinFilterSecam;		//toggle secam phase filter 
			}

#ifdef MM_LINUX
				*pbViewBuffer = TRUE;
#endif
		} else {		
			// update input buffer : cricri : moved from even to odd treatement
            // as long as this is already done in FindKey() for even field
			pLaVache->UpdateInputLine( VideoPlugin.OddLines[nCurrentFrame],
									   bIsOdd);
			pLaVache->RecordKeyRepeat( true, 0);
		}
	}

#ifndef MM_LINUX
	*pbUpdateBuffer = VideoPlugin.FullField || !bIsOdd;		// cricri
    *pbViewBuffer = VideoPlugin.FullField == bIsOdd;		// cricri
#endif

	//wait (debug)
	if (bWait)
	{
		bWait=false;
		Sleep(41);		//debug
	}

#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------

	// Capture is ON (NiKral)
	if (bCaptureOn)
	{	
		bCaptureOn=false;
		pCapture->CreateBMPFile( VideoPlugin.CurrentX, CURRENTY,VideoPlugin.MovieBoost,
								 bIsOdd,VideoPlugin.FullField,
								 VideoPlugin.OddLines[nPreviousFrame],
								 VideoPlugin.EvenLines[nPreviousFrame],
								 VideoPlugin.OutOddLines[nPreviousFrame],
								 VideoPlugin.OutEvenLines[nPreviousFrame]);
	}

	//calcul CpuUsed
	__int64 nTimeProcess=GetRDTSCTime()-nTimeCurrent;
	if (nDeltaTime>0)
	{
		float fCpuCurrent=(float)nTimeProcess*100/(float)nDeltaTime;

		//average (low pass filter)
		fCpuUsed=(fCpuUsed*(float)80.0+fCpuCurrent)/(float)81.0;
		if (fCpuUsed>100)
			fCpuUsed=100;
	}

//--- Windows Section (END) ------------------------------------------------------
#endif
}
 
#ifndef MM_LINUX
//--- Windows Section (BEGIN) ----------------------------------------------------

void CheckStuff(void)
{
}	

//show parameters dialogue
void ShowDialog()
{
	if(pAjustParamDlg)
	{
		bFullField=VideoPlugin.FullField;
		pAjustParamDlg->SetParams(nTestNormalUser,nTestPreviousUser, \
								  bFilterSecam,bFilterPurple,bFilterAverage, \
								  bFilterEMMX,bFilterSSE,nPurpleLevel,bFullField,\
								  sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);
		if (pAjustParamDlg->DoModal(VideoPlugin.hDllInstance,VideoPlugin.hwndParent)==IDOK)
		{
			if (pAjustParamDlg->GetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple,bFilterAverage, \
				bFilterEMMX,bFilterSSE,nPurpleLevel,bFullField,sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack))
			{
				//update file
				bInitFile=true;
			}

			// #define IDM_FullFields                  360
			if (VideoPlugin.FullField!=(bFullField!=0))
			{
				VideoPlugin.FullField=(bFullField!=0);
				SendMessage(VideoPlugin.hwndParent, WM_COMMAND, 360, 0);
			}

			pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
								bFilterSecam,bFilterPurple,bFilterAverage, \
								bFilterEMMX,bFilterSSE,nPurpleLevel);
			pCapture->SetParams(sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);
		}
        CheckMenu(GetMenu(VideoPlugin.hwndParent));  // cricri
	}
}



HMENU GetPluginMenu( BOOL ContextMenu)
{
	HMENU CurMenu;
	CurMenu = LoadMenu(VideoPlugin.hDllInstance, MAKEINTRESOURCE(IDR_MENU1)); 
	CheckMenu(CurMenu);
	if ( !ContextMenu)			// cricri
		hStdMenu = CurMenu;
	return CurMenu;

	UNREFERENCED_PARAMETER( ContextMenu);
}


void CheckMenu(HMENU hMenu) 
{

	// NiKral
	//if (bDetectSignalOver)
	//	CheckMenuItem( hMenu, IDM_PLUGIN_VIDEO_FORCE, MF_CHECKED);
	//else
	//	CheckMenuItem( hMenu, IDM_PLUGIN_VIDEO_FORCE, MF_UNCHECKED);

	if (hMenu == NULL)			// cricri for safety
		return;

	if (bFilterSecam!=FALSE)
		CheckMenuItem( hMenu, ID_FILTER_SECAM, MF_CHECKED);
	else
		CheckMenuItem( hMenu, ID_FILTER_SECAM, MF_UNCHECKED);

	if (bFilterPurple!=FALSE)
		CheckMenuItem( hMenu, ID_FILTER_PURPLE, MF_CHECKED);
	else
		CheckMenuItem( hMenu, ID_FILTER_PURPLE, MF_UNCHECKED);
	
	// cricri
	if (bFilterAverage!=FALSE)
		CheckMenuItem( hMenu, ID_FILTER_AVERAGE, MF_CHECKED);
	else
		CheckMenuItem( hMenu, ID_FILTER_AVERAGE, MF_UNCHECKED);

}


//ProcessMessage
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{	
	HMENU hMenu = GetMenu(VideoPlugin.hwndParent);
	sprintf(OSDDisplay,"");
	BOOL messageProcessed = FALSE;
	switch (message)
	{
		case WM_COMMAND:
			switch( LOWORD( wParam ))
			{
				case IDM_HELP_PLUGIN:
				{
					HtmlHelp( GetDesktopWindow(),
							"Aide/AidePlugin.chm::/0Plugin.htm",
							HH_DISPLAY_TOPIC,NULL);
					sprintf(OSDDisplay, "Aide Plugins ...");
					messageProcessed = TRUE;
				}
				break;

				case ID_FILTER_SECAM:
				{
					if (bFilterSecam!=FALSE)
					{
						bFilterSecam=FALSE;
						sprintf(OSDDisplay, "Filtre anti-bavures dsactiv");
					}
					else
					{
						bFilterSecam=TRUE;
						sprintf(OSDDisplay, "Filtre anti-bavures activ");
					}

					pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
										bFilterSecam,bFilterPurple,bFilterAverage, \
										bFilterEMMX,bFilterSSE,nPurpleLevel);
					
					CheckMenu(hMenu);
					messageProcessed = TRUE;
				}
				break;

				case ID_FILTER_PURPLE:
				{
					if (bFilterPurple!=FALSE)
					{
						bFilterPurple=FALSE;
						sprintf(OSDDisplay, "Filtre lignes violettes dsactiv");
					}
					else
					{
						bFilterPurple=TRUE;
						sprintf(OSDDisplay, "Filtre lignes violettes activ");
					}

					pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
										bFilterSecam,bFilterPurple,bFilterAverage, \
										bFilterEMMX,bFilterSSE,nPurpleLevel);

					CheckMenu(hMenu);
					messageProcessed = TRUE;
				}
				break;

				case ID_FILTER_AVERAGE:
				{
					if (bFilterAverage!=FALSE)
					{
						bFilterAverage=FALSE;
						sprintf(OSDDisplay, "Filtre moyenneur dsactiv");
					}
					else
					{
						bFilterAverage=TRUE;
						sprintf(OSDDisplay, "Filtre moyenneur activ");
					}

					pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
										bFilterSecam,bFilterPurple,bFilterAverage, \
										bFilterEMMX,bFilterSSE,nPurpleLevel);

					CheckMenu(hMenu);
					messageProcessed = TRUE;
				}
				break;

				// NiKral : filtre(s) actif(s) + conso. CPU
				case IDM_INFO_OSD_MM:
				{
					int	nTestFilter=0;
					
					if (bFilterSecam!=FALSE)
						nTestFilter++;
					if (bFilterPurple!=FALSE)
						nTestFilter+=2;
					if (bFilterAverage!=FALSE)
						nTestFilter+=4;

					switch (nTestFilter)
					{
						case 0:
							sprintf(OSDDisplay, "Aucun filtre actif [CPU:%.2f]",fCpuUsed);
							break;

						case 1:
							sprintf(OSDDisplay, "Filtre AB actif [CPU:%.2f]",fCpuUsed);
							break;

						case 2:
							sprintf(OSDDisplay, "Filtre LV actif [CPU:%.2f]",fCpuUsed);
							break;

						case 3:
							sprintf(OSDDisplay, "Filtres AB+LV actifs [CPU:%.2f]",fCpuUsed);
							break;

						case 4:
							sprintf(OSDDisplay, "Filtre Moy actif [CPU:%.2f]",fCpuUsed);
							break;

						case 5:
							sprintf(OSDDisplay, "Filtres AB+Moy actifs [CPU:%.2f]",fCpuUsed);
							break;

						case 6:
							sprintf(OSDDisplay, "Filtres LV+Moy actifs [CPU:%.2f]",fCpuUsed);
							break;

						case 7:
							sprintf(OSDDisplay, "Les 3 filtres actifs [CPU:%.2f]",fCpuUsed);
					}
					messageProcessed = TRUE;
				}
				break;
				
				case ID_CAPTURE_ON:
				{
					bCaptureOn=true;
					sprintf(OSDDisplay, "Capture d'cran active");
					messageProcessed = TRUE;
				}
				break;

				case ID_LESS_PURPLE_LEV:
				case ID_MORE_PURPLE_LEV:
				{
					if (LOWORD(wParam)==ID_LESS_PURPLE_LEV)
					{
						if (nPurpleLevel > PURPLELEVELMINI) nPurpleLevel--;				
					}
					else
					{
						if (nPurpleLevel < PURPLELEVELMAXI) nPurpleLevel++;
					}
					sprintf(OSDDisplay,"Nouveau seuil violet : %d",nPurpleLevel);

					pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
										bFilterSecam,bFilterPurple,bFilterAverage, \
										bFilterEMMX,bFilterSSE,nPurpleLevel);

					messageProcessed = TRUE;
				}
				break;

				//debug
				case ID_WAIT:
				{
					bWait=true;
					messageProcessed = TRUE;
				}
				break;

				//debug
				case ID_SAVEIMAGE:
				{
					if ((!pLaVache)||(!pLaVache->IsInit()))
						return true;

					bSaveImage=true;
					sprintf(OSDDisplay, "Image saved");
					messageProcessed = TRUE;
				}
				break;

				//debug
				case ID_LOADIMAGE:
				{
					if ((!pLaVache)||(!pLaVache->IsInit()))
						return TRUE;

					bLoadImage=!bLoadImage;
					pLaVache->SetLoadImageMode(bLoadImage);
			
					if (bLoadImage)
					{
						if (pLaVache->LoadImage())
							sprintf(OSDDisplay, "Image loaded");
						else
						{
							bLoadImage=false;
							pLaVache->SetLoadImageMode(bLoadImage);
							sprintf(OSDDisplay, "Image not loaded");
						}
					}
					else sprintf(OSDDisplay, "Image unloaded");
					messageProcessed = TRUE;
				}
				break;
			

			}
			break;
	}
	return messageProcessed;
}

//--- Windows Section (END) ------------------------------------------------------
#endif

//satut bar
void GetStatus(char * Text, BOOL Nb)
{
	char s[128];
	sprintf(s,"");

	if (Nb)
	{
		sprintf(s,"MeuhMeuhPlug  CPU %.2f%%",fCpuUsed);
		//sprintf(s,"MeuhMeuhPlug  %d",pLaVache->GetHeightBlackDynam());
		
		strcpy(Text, s);	
	}

	strcpy(Text, s);	
}

// ?
void SetLow(unsigned char bBrightness)
{
	
}


BOOL AutoMovieBoostFound()
{
	//disable

	//bug ! probleme with k!tv when VideoPlugin.MovieBoost value change

	if (abs(VideoPlugin.MovieBoost-pLaVache->GetHeightBlackDynam())>4)
	{
		VideoPlugin.MovieBoost=pLaVache->GetHeightBlackDynam();
		return TRUE;
	}

	return FALSE;
}


// cricri
int GetNbrOfMissingField( int nCurrentFrame, BOOL bIsOdd)
{
    static int  nPreviousField;
    int nMissingField, nCurrentField = nCurrentFrame * 2 + (bIsOdd ? 1 : 0);


    if ( nCurrentField > nPreviousField)
		nMissingField = nCurrentField - nPreviousField - 1;
	else
#ifndef MM_LINUX
		//--- Windows Section
		nMissingField = nCurrentField - nPreviousField + 9;
#else
		//--- Linux Section
		nMissingField = nCurrentField - nPreviousField + VideoPlugin.NbBuff * 2 - 1;
#endif

	nPreviousField = nCurrentField;

    return( nMissingField);

}


/////////////////////////////////////////////////////////////////////////////
// DetecteSignal is based on Albator Plugin
// Thanks Grincheux !
/////////////////////////////////////////////////////////////////////////////
BOOL DetecteSignal(BYTE *pVBI) 
{
	// NiKral
	//if (bDetectSignalOver)
	//	return TRUE;
	
	float fSignalDetect=0;
	int i,j,row;
	BOOL text_lines_found=FALSE;
	static BOOL retval;
	unsigned char vbiline[2048];
	unsigned char vbibits[2048/4];
	unsigned char vbibytes[2048/4/8];
	int AutoID_Offset=4;
	unsigned int AutoID_sample_bits[48]=
	{
	 0,7,15,23,31,39,47,55,63,71,79,87,95,103,
	 111,119,126,134,142,150,158,166,174,182,
	 190,198,206,214,222,230,238,245,
	 253,261,269,277,285,293,301,309,317,325,
	 333,341,349,357,364,372
	};

	//no valid VBI signal
	if (pVBI == NULL)
		fSignalDetect=0;
	else
	{

		text_lines_found=FALSE;
		
		for(row=0; row<32; row++)
		{
			for (i=0;i<2048;i++)
			{
       			if (*(pVBI++) < 95) vbiline[i]=0;
				else vbiline[i]=1;
			}
			i=0;
			while (vbiline[i]!=1) 
				if (i++ > 2048) break;
			if (i>200) continue;
			for (j=0;j<48 ;j++) vbibits[j]=vbiline[AutoID_sample_bits[j]+AutoID_Offset+i];

			for (i=0;i<48;i+=8)
			{
				vbibytes[i/8]=0;
				for (j=0;j<8;j++) vbibytes[i/8]|=vbibits[i+j]<<j;  // inverse order
			}
			if (vbibytes[0]==0x55) text_lines_found=TRUE;
			if ((vbibytes[0]==0x55) && (vbibytes[4]==0x15))
			{
				if  (vbibytes[5]&0x20)
				{
					retval = TRUE;
					break;
				}
				else retval = FALSE;
			}
		}
		if ( text_lines_found == FALSE ) retval=FALSE;
	}

	if (retval)
		fSignalDetect=1;

	fLevelSignalDetect=(fLevelSignalDetect*5.0+fSignalDetect)/6.0;

	if (fLevelSignalDetect>0.5)
		return TRUE;
	else
	{
		fCpuUsed=0;
		return FALSE;
	}

}


__int64 GetRDTSCTime() 
{
    union 
	{
	  __int64 ll;
	  struct { int lo;int hi ;} s;
	} time;

	__asm
	{
		cpuid
		rdtsc
		mov time.s.lo, eax
		mov time.s.hi, edx
	}

	return time.ll;
}


#ifdef MM_LINUX
//--- Linux Section (BEGIN) ------------------------------------------------------

static void DoFPC(void)
{
	if(pAjustParamDlg)
	{
		pAjustParamDlg->SetParams(nTestNormalUser,nTestPreviousUser, \
								  bFilterSecam,bFilterPurple,bFilterAverage, \
								  bFilterEMMX,bFilterSSE,nPurpleLevel,bFullField,\
								  sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);
		pAjustParamDlg->BuildFPC((void *) 0);
		pAjustParamDlg->GetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple,bFilterAverage, \
				bFilterEMMX,bFilterSSE,nPurpleLevel,bFullField,sCapFileName,bCapCrypt,bCapHalfField,bCapNoBlack);	
		pLaVache->SetParams(nTestNormalUser,nTestPreviousUser, \
								bFilterSecam,bFilterPurple,bFilterAverage, \
								bFilterEMMX,bFilterSSE,nPurpleLevel);
		SaveParams();
		bInitFile=true;
	}
}

static bool LoadParams(void)
{
	char file[255], ligne[256], name[20];
	int val;
	nTestNormalUser = nTestPreviousUser = -1;
	sprintf(file, "%s/%s", home_dir, NomFichierINI);
	printf("Loading %s \n",file);
	FILE *sFile = fopen(file, "r");
	if(sFile == NULL) return false;
	while (fgets(ligne,256,sFile))
	{
		sscanf(ligne,"%40s = %d",name,&val);
		for(int i=0;cfg[i].name;i++)
		if(strcmp(cfg[i].name,name)==0)
		{
			*(cfg[i].val)=val;
			printf("%s --> %d\n",name,val);
		}
	}
	fclose(sFile);
	return nTestNormalUser>=0 && nTestPreviousUser>=0;
}

static bool SaveParams(void)
{
	char file[255];
	sprintf(file, "%s/%s", home_dir, NomFichierINI);
	printf("Saving in %s \n",file);
	FILE *sFile = fopen(file, "w");
	if(sFile == NULL) return false;
	for(int i=0;cfg[i].name;i++)
	{
		fprintf(sFile,"%s = %d\n",cfg[i].name,*(cfg[i].val));
	}
	fclose(sFile);
	return true;
}

//--- Linux Section (END) --------------------------------------------------------
#endif
