#ifndef _KIZKOOL_H

// Should really be defined somewhere else....
# ifndef FALSE
#  define FALSE 0
# endif
# ifndef TRUE
#  define TRUE (!FALSE)
# endif

#ifndef DISABLE_ALL_KIZKOOL

#undef TUNE_SNABRAB

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

#ifdef ENABLE_KIZKOOL25
# define U_FILTER_THRESHOLD_K25   55    // Should start at 55 %
# define V_FILTER_THRESHOLD_K25   55    // Should start at 55 %
#endif

#ifdef ENABLE_KIZKOOL28
# define U_FILTER_THRESHOLD_K28   55    // Should start at 55 %
# define V_FILTER_THRESHOLD_K28   55    // Should start at 55 %
#endif

#ifdef ENABLE_KIZKOOL30
# define U_FILTER_THRESHOLD_K30   60    // Should start at 60 %
# define V_FILTER_THRESHOLD_K30   60    // Should start at 60 %
# define YUV_FILTER_THRESHOLD_K30 40    // Should start at 40 %
# define PIX_FILTER_THRESHOLD_K30 20    // Should start at 20 %
#endif

#ifdef ENABLE_KIZKOOL31
# define U_FILTER_THRESHOLD_K31   60    // Should start at 60 %
# define V_FILTER_THRESHOLD_K31   60    // Should start at 60 %
# define YUV_FILTER_THRESHOLD_K31 40    // Should start at 40 %
# define PIX_FILTER_THRESHOLD_K31 20    // Should start at 20 %
#endif

#ifdef ENABLE_KIZKOOL32
# define U_FILTER_THRESHOLD_K32   63    // Should start at 63 %
# define V_FILTER_THRESHOLD_K32   63    // Should start at 63 %
# define YUV_FILTER_THRESHOLD_K32 43    // Should start at 43 %
# define PIX_FILTER_THRESHOLD_K32 20    // Should start at 20 %
#endif

#ifdef ENABLE_SNABRAB
# define U_FILTER_THRESHOLD_K32SNABRAB   63    // Should start at 63 %
# define V_FILTER_THRESHOLD_K32SNABRAB   63    // Should start at 63 %
# define YUV_FILTER_THRESHOLD_K32SNABRAB 43    // Should start at 43 %
# define PIX_FILTER_THRESHOLD_K32SNABRAB 20    // Should start at 20 %

# define FIRSTLINE_SNABRAB 32
# define LASTLINE_SNABRAB  52
# define THRESHOLD_SNABRAB  8
#endif

struct kizkool_param_t
{
  int smudge;                   // Boolean: SMUDGEFILTER_ON / SMUDGEFILTER_OFF
  int iUFilterThresholdPCent;
  int iVFilterThresholdPCent;

  int iYUVFilterThresholdPCent; // for KizKoool filter >= 3.0
  int iPixFilterThreshold;      // for KizKoool filter >= 3.0

  int nUThreshold;              // for KizKoool filter >= 3.2
  int nVThreshold;              // for KizKoool filter >= 3.2
  int nYUVThreshold;            // for KizKoool filter >= 3.2

};
typedef struct kizkool_param_t KIZKOOL_PARAM;

#ifdef ENABLE_SNABRAB
struct snabrab_param_t
{
  int FirstLine;
  int LastLine;
  int Threshold;
};
typedef struct snabrab_param_t SNABRAB_PARAM;
#endif

enum {
  KIZKOOL_SMUDGE = 1,
  KIZKOOL_UTHRESHOLD,
  KIZKOOL_VTHRESHOLD,
  KIZKOOL_YUVTHRESHOLD,
  KIZKOOL_PIXFILTERTHRESHOLD,
  KIZKOOL_SNABRAB_FIRSTLINE,
  KIZKOOL_SNABRAB_LASTLINE,
  KIZKOOL_SNABRAB_THRESHOLD
};


void init_kizkool_filter (void);


#ifdef ENABLE_SNABRAB
 /* For version 3.2 enhanced by snabrab */
 // Public
 void init_kizkool32snabrab_filter (void);
 void FindFrameType32snabrab (long **pLinesAddress, unsigned short *pSortLines);
 void SecamFiltering32snabrab (long **pLinesAddress, unsigned short *pSortLines);

 // Private
# ifdef KIZKOOOL_32SNABRAB
# ifndef BYTE
#  define BYTE unsigned char
# endif
  static int LineSaturation (long *pQuelle, int CountX, int iLine_bugne, int iLine_sort, int Zone2_bugne);
  static int NbFramesManquantes (void);
  static int TestCorrectionUV (long *pQuelle, long *pSauve, long *pColorQuelle,
                 long MasqueUV);
# endif
#endif

#ifdef ENABLE_KIZKOOL32
 /* For version 3.2 */
 // Public
 void init_kizkool32_filter (void);
 void FindFrameType32 (long **pLinesAddress, unsigned short *pSortLines);
 void SecamFiltering32 (long **pLinesAddress, unsigned short *pSortLines);

 // Private
# ifdef KIZKOOOL_32
# ifndef BYTE
#  define BYTE unsigned char
# endif
  static int LineSaturation (long *pQuelle, int CountX);
  static int NbFramesManquantes (void);
  static int TestCorrectionUV (long *pQuelle, long *pSauve, long *pColorQuelle,
                 long MasqueUV);
# endif
#endif


#ifdef ENABLE_KIZKOOL31
 /* For version 3.1 */
 // Public
 void init_kizkool31_filter (void);
 void FindFrameType31 (long **pLinesAddress, unsigned short *pSortLines);
 void SecamFilter31 (long **pLinesAddress, unsigned short *pSortLines);
 void FilterBlueLines31 (long **pLinesAddress, unsigned short *pSortLines);

 // Private
# ifdef KIZKOOOL_31
# ifndef BYTE
#  define BYTE unsigned char
# endif
  static int LineSaturation (long *pQuelle, int CountX);
  static int NbFramesManquantes (void);
  static int TestCorrectionUV (long *pQuelle, long *pSauve, long *pColorQuelle,
                 unsigned long MasqueUV);
# endif
#endif


#ifdef ENABLE_KIZKOOL30
 /* For version 3.0 */
 // Public
 void init_kizkool30_filter (void);
 void FindFrameType30 (long **pLinesAddress, unsigned short *pSortLines);
 void SecamFilter30 (long **pLinesAddress, unsigned short *pSortLines);
 void FilterBlueLines30 (long **pLinesAddress, unsigned short *pSortLines);

// Private
# ifdef KIZKOOOL_30
  static int Secam_UVValue (long *pQuelle, int CountX);
  static void CorrectionMMX (long *pQuelle, long *pSauve, long *pColorQuelle,
               unsigned long long MasqueUV);
  static int NbFramesManquantes (void);
# endif
#endif


#ifdef ENABLE_KIZKOOL28
 /* For version 2.8 */
 // Public
 void init_kizkool28_filter (void);
 void FilterBlueLines28 (long **pLinesAddress, unsigned short *pSortLines);
 void SecamFilter28 (long **pLinesAddress, unsigned short *pSortLines);

 // Private
# ifdef KIZKOOOL_28
  static int Secam_UVValue (long *pQuelle, int CountX);
# endif
#endif

#ifdef ENABLE_KIZKOOL25
 /* For version 2.5 */
 // Public
 void init_kizkool25_filter (void);
 void FilterBlueLines25 (long **pLinesAddress, unsigned short *pSortLines,
            int bEven);

 // Private
# ifdef KIZKOOOL_25
  static void Secam_UVValue (long *pQuelle, int CountX, int *etat_ligne);
# endif
#endif

#endif //DISABLE_ALL_KIZKOOL

#define  _KIZKOOL_H
#endif
