/*********************************************************************************
 *                                                                               *
 * kizkool25.c                                                                   *
 *                                                                               *
 * This code has been developped by KizKoool and others for Multidec-SE          *
 * and adapted by Keuleu for xawdecode                                           *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 *********************************************************************************/
#include <stdio.h>
#include "config.h"
#define KIZKOOOL_25
#include "filtre.h"
#include "kizkool.h"
void set_bluefilter_params (int filter, ...);

#ifdef ENABLE_KIZKOOL25

#define DWORD long

// KizKoool extensions
#define ZEILENZAHL           287
static int iFilterNbBlocs = 24;    //Should start at 24 blocs per line
static int nUThreshold;
static int nVThreshold;
static int iLine;

// Declared in kizkool.c
/*
extern int iUFilterThresholdPCent;
extern int iVFilterThresholdPCent;
*/
extern int debug;

extern KIZKOOL_PARAM kizkool_param[NB_KIZKOOL_FILTER];

extern int CurrentX;
extern int MovieScale;

static int nAbsorption;
static int SeuilU[ZEILENZAHL];
static int SeuilV[ZEILENZAHL];
static int iFilterAbsorption = 25;    //Should start at 25 %

static unsigned long long nMaske = 0x00ff00ff00ff00ffLL;
static unsigned long long nMaskeUV = 0xFF00FF00FF00FF00LL;

//////////////////////////////////// KizKoool 2.5 /////////////////////////////////////

// Filtre KizKoool v2.5

// Secam Functions by Fantasio
// Blue filter v2.0 + ASM translation by 1konnu (Original idea from Z)
// Some bugfixes by e-nek (e-nek@netcourrier.com)
//
// Completely new and more efficient "blue lines" detection + bugfixes +
// + Line independant threshold UV values +
// MMX translation of Blue filter v2.0 by KizKoool
//
void
init_kizkool25_filter (void)
{
  if (debug)
    fprintf(stderr, "kizkool25: init filter\n");
  //kizkool_param[BLUEFILTER_K25 - 1].smudge = -1;    //irrelevant
  // Actually, it's an irrelevant parameter, but it's better to have it defined
  set_bluefilter_params(BLUEFILTER_K25, KIZKOOL_SMUDGE, SMUDGEFILTER_OFF, 0);
  set_bluefilter_params(BLUEFILTER_K25, KIZKOOL_UTHRESHOLD, (U_FILTER_THRESHOLD_K25*65535)/100, 0);
  set_bluefilter_params(BLUEFILTER_K25, KIZKOOL_VTHRESHOLD, (V_FILTER_THRESHOLD_K25*65535)/100, 0);
  kizkool_param[BLUEFILTER_K25 - 1].iYUVFilterThresholdPCent = -1;    //irrelevant
  kizkool_param[BLUEFILTER_K25 - 1].iPixFilterThreshold = -1;    //irrelevant
  kizkool_param[BLUEFILTER_K25 - 1].nUThreshold = -1;    //irrelevant
  kizkool_param[BLUEFILTER_K25 - 1].nVThreshold = -1;    //irrelevant
  kizkool_param[BLUEFILTER_K25 - 1].nYUVThreshold = -1;    //irrelevant
}
void
FilterBlueLines25 (long **pLinesAddress, unsigned short *pSortLines,
                   int bEven)
{
  int saturee;

  // La zone est limite  287 x 768 (est-ce toujours vrai ?)
  static long ColorBackup[ZEILENZAHL * 768];

  long *pQuelle, *pColorQuelle, *pix_courant;

  nUThreshold =
    (int) (kizkool_param[BLUEFILTER_K25 - 1].iUFilterThresholdPCent * 0.01 *
           0xff);
  nVThreshold =
    (int) (kizkool_param[BLUEFILTER_K25 - 1].iVFilterThresholdPCent * 0.01 *
           0xff);
  nAbsorption = (int) (iFilterAbsorption * 0.01 * 0xff);

  // Remise  jour du tableau des seuils UV si changement dans les paramtres de seuil

  if ((SeuilU[0] != nUThreshold) || (SeuilV[0] != nVThreshold))
    {
      for (iLine = 0; iLine <= ZEILENZAHL; iLine++)
        {
          SeuilU[iLine] = (int) (nUThreshold / (1 + (nAbsorption / 100)));
          SeuilV[iLine] = (int) (nVThreshold / (1 + (nAbsorption / 100)));
        }
    }

  for (iLine = 1 + MovieScale; iLine < ZEILENZAHL - MovieScale; iLine++)
    {

      Secam_UVValue ((long *) pLinesAddress[pSortLines[iLine]], CurrentX / 2,
                     &saturee);

      ////////////////////////////////////////////////////////////////////
      // Zone suprieure et infrieure de l'image
      // Utiliser le filtre bleu v2.0
      //
      // Bas sur le code d'1Konnu
      // Corrections du code d'1Konnu par E-Nek
      //
      // Modifications additionnelles de ce filtre par KizKoool:
      //   - Support de la nouvelle interface de la fonction Secam_UVValue
      //         - Traduction du code x86 en code MMX + Optimisations
      ////////////////////////////////////////////////////////////////////
      pQuelle = (long *) pLinesAddress[pSortLines[iLine]];
      pColorQuelle = (long *) ColorBackup + CurrentX * iLine;


      /*
         if (saturee)
         {
         // ligne saturee
         for (pix_courant=pColorQuelle; pix_courant<pColorQuelle+(CurrentX/2); pix_courant++)
         {
         *pQuelle=((*pQuelle & 0x00FF00FF) | (*pix_courant & 0xFF00FF00));
         pQuelle++;
         }
         }
         else
         {  // ligne non saturee
         for (pix_courant=pQuelle; pix_courant<pQuelle+(CurrentX/2); pix_courant++)
         {
         *pColorQuelle=*pix_courant;
         pColorQuelle++;
         }
         }
       */



      __asm__ (
                /*
                   "pushl %%edi                  \n\t"
                   "pushl %%esi                  \n\t"
                 */
                "movl %0, %%ecx               \n\t"    // CurrentX
                "movl %1, %%edi               \n\t"    // pQuelle
                "movl %2, %%esi               \n\t"    // pColorQuelle
                "cmpl $1, %3                  \n\t"    // saturee
                "jge 2f                       \n\t" //bugne  // saut si la ligne est sature
                //
                // Sauvegarder la ligne en mmoire si elle est bonne
                //
                ".align 16                    \n\t"
                "0:                           \n\t" //PixSui
                "movq (%%edi), %%mm0          \n\t"
                "movq %%mm0, (%%esi)          \n\t"
                "addl $8, %%edi               \n\t"
                "addl $8, %%esi               \n\t"
                "subl $4, %%ecx               \n\t"
                "jz 5f                        \n\t" //fin
                "cmpl $2, %%ecx               \n\t"
                "je 1f                        \n\t" //PixFin
                "jmp 0b                       \n\t" //PixSui
                "1:                           \n\t" //PixFin
                "movl (%%edi), %%eax          \n\t"
                "movl %%eax, (%%esi)          \n\t"
                "jmp 5f                       \n\t" //fin
                //
                // Correction de la ligne si elle est sature
                //
                "2:                           \n\t" //bugne
                "movq nMaske, %%mm4           \n\t"
                "movq nMaskeUV, %%mm5         \n\t"
                ".align 16                    \n\t"
                "3:                           \n\t" //PixSuiv
                "movq (%%edi), %%mm0          \n\t"    // mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
                "movq (%%esi), %%mm1          \n\t"    // mm1 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
                "pand %%mm4, %%mm0            \n\t"    // mm0 = 00 Y3 00 Y2 00 Y1 00 Y0
                "pand %%mm5, %%mm1            \n\t"    // mm1 = V2 00 U2 00 V0 00 U0 00
                "por  %%mm1, %%mm0            \n\t"
                "movq %%mm0, (%%edi)          \n\t"
                "addl $8, %%edi               \n\t"
                "addl $8, %%esi               \n\t"
                "subl $4, %%ecx               \n\t"
                "jz 5f                        \n\t" //fin
                "cmpl $2, %%ecx               \n\t"
                "je 4f                        \n\t" //PixFinal
                "jmp 3b                       \n\t" //PixSuiv
                "4:                           \n\t" //PixFinal
                "movl (%%edi), %%eax          \n\t"
                "movl (%%esi), %%ebx          \n\t"
                "andl $0x00ff00ff, %%eax      \n\t"
                "andl $0xff00ff00, %%ebx      \n\t"
                "orl %%ebx, %%eax             \n\t"
                "movl %%eax, (%%edi)          \n\t"
                "5:                           \n\t" //fin
                "emms                         \n\t"
                /*
                   "popl %%esi                   \n\t"
                   "popl %%edi                   \n\t"
                 */
    :                            /* output regs/vars */

    :                            /* input regs */
                "m" (CurrentX),    /* %0 */
                "m" (pQuelle),    /* %1 */
                "m" (pColorQuelle),    /* %2 */
                "m" (saturee)    /* %3 */
    :                            /* clobber list */
                "eax", "ebx", "ecx", "edi", "esi");

    }                            // boucle for
}



////////////////////////////////////////////////////
// Code de la fonction Secam_UVValue par KizKoool //
////////////////////////////////////////////////////

static void
Secam_UVValue (long *pQuelle, int CountX, int *etat_ligne)
{
  long *pix_courant;
  long U, V, Usomme, Vsomme;
  int nPixBloc, Bloc_courant, TmpFilterNbBlocs;

  U = 0xff;
  V = 0xff;
  *etat_ligne = 3;
  Bloc_courant = 0;

  TmpFilterNbBlocs = iFilterNbBlocs;

  if (iLine > ZEILENZAHL - 64)
    {
      iFilterNbBlocs = iFilterNbBlocs / 3;
    }
  if (iLine > ZEILENZAHL - 32)
    {
      iFilterNbBlocs = iFilterNbBlocs / 2;
    }
  if (iFilterNbBlocs == 0)
    {
      iFilterNbBlocs = 1;
    }

  while ((Bloc_courant < iFilterNbBlocs)
         && ((U > nUThreshold / (1 + (nAbsorption / 100)))
             || (V > nVThreshold / (1 + (nAbsorption / 100)))))
    {

      Usomme = 0;
      Vsomme = 0;

      nPixBloc =
        ((int) CountX * (Bloc_courant + 1) / iFilterNbBlocs) -
        ((int) CountX * Bloc_courant / iFilterNbBlocs);

      for (pix_courant = pQuelle; pix_courant < pQuelle + nPixBloc;
           pix_courant++)
        {

          Usomme += *pix_courant >> 8 & 0xff;
          Vsomme += *pix_courant >> 24 & 0xff;

          // Debug mode
          // *pix_courant=*pix_courant & 0x00ff00ff;
        }

      pQuelle += nPixBloc;

      U = min (Usomme / nPixBloc, U);
      V = min (Vsomme / nPixBloc, V);

      if (iLine > 1)
        {
          *etat_ligne =
            (U > ((1 + (nAbsorption / 100)) * SeuilU[iLine - 1])) * 2 + (V >
                                                                         ((1
                                                                           +
                                                                           (nAbsorption
                                                                            /
                                                                            100))
                                                                          *
                                                                          SeuilV
                                                                          [iLine
                                                                           -
                                                                           1]));
        }
      else
        {
          *etat_ligne =
            (U > ((1 + (nAbsorption / 100)) * SeuilU[iLine])) * 2 + (V >
                                                                     ((1
                                                                       +
                                                                       (nAbsorption
                                                                        /
                                                                        100))
                                                                      *
                                                                      SeuilV
                                                                      [iLine]));
        }

      Bloc_courant++;
    }

  if (*etat_ligne == 0)
    {
      SeuilU[iLine] = max (U, nUThreshold / (1 + (nAbsorption / 100)));
      SeuilV[iLine] = max (V, nVThreshold / (1 + (nAbsorption / 100)));
    }
  iFilterNbBlocs = TmpFilterNbBlocs;
}
#endif
