#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <string.h>
//#include <pthread.h>
#ifdef HAVE_XVID
#include <xvid.h>
#endif

#include "videodev.h"
#include "videodev2.h"
#include "bttv.h"

#include "colorspace.h"
#include "grab.h"

#include "crypt.h"
#include "nagra.h"
#include "ch5.h"
#include "vcrypt.h"
#include "const.h"
#include "oldcrypt.h"
#include "wintv_colors.h"
#include "vcryptkrank.h"
#include "xcrypt.h"
#include "attributes.h"
#include "cpu_accel.h"
#include "filtre.h"
#include "memcpy.h"

//extern pthread_mutex_t grab_mutex;
extern int have_xv;
extern int bttvfd;
extern int auto_decode;
extern int highquality;
extern int nagra_coded;
extern int use_nagraudio;
extern int bpp;
extern int ybar;
extern int ybar_auto;
extern struct GRABBER *grabbers[];
extern struct GRABBER grab_v4l;
extern struct GRABBER grab_v4l2;
int v4l,v4l2;
#ifdef HAVE_XVID
extern struct GRABBER grab_avi;
extern void * avi_extract_frame(int width, int height);
extern int avi_out_bytes, avi_out_format;
static int avi_out_bytes_clear, avi_out_format_clear;
int avi;
static int width_capture_clear;
extern void video_set_capture_size(int w, int h);
extern void video_get_capture_size(int *w, int *h);
#endif

void *(*grab_scr_clear) (void *,int,int,int,int);
void *(*grab_one_clear) (int,int,int);
int gbformat_clear,pixmap_bytes_clear;
int pixelformat_clear;
extern int overlay;
extern void video_overlay
(int (*set_overlay)(int,int,int,int,int,struct OVERLAY_CLIP *,int));
int grabber_sau;
int grabbing_one=0;
int forceburst=0;

#ifndef DISABLE_ALL_KIZKOOL
 extern unsigned int CurrentFrame;
#endif
static int bttvpriv=0; // private bbtv ioctl allowed ?

int decode = NAGRA;
extern int have_MMX;
int use_nagraudio = 0;
int nagraudio_mode = NAGRAUDIO_AUTO;

extern int x11_pixmap_format;
extern int x11_native_format;

int get_img(int width,int height,unsigned int format);

extern struct video_mmap *gb;
extern int gbformat,gbwidth,gbheight;
extern char *map;
extern int pixmap_bytes;
extern struct video_mbuf gb_buffers;
extern int img;
extern int nbufs;

extern struct v4l2_format gbformat2;
char *get_img2(void);
int changeformat(struct v4l2_format *);

extern int cur_maxwidth, cur_maxheight, cur_secam;
extern int nagra_coded;
extern int number_couples;
extern int use_alternate_rescale;

extern void set_sound_decoder (int mode, char *label);
extern void start_nagraudio (void);
extern void changedecode(int);

void (*decode_fullframe)
  (unsigned char *dest,
   unsigned char *src,
   int xsize_dest, int xsize_src, int ysize, int dest_xsize) = NULL;
void (*decode_halfframe)
  (unsigned char *dest,
   unsigned char *src,
   int xsize_dest, int xsize_src, int ysize, int dest_xsize) = NULL;


static inline int div_round (int dividend, int divisor)
{
  return (dividend + (divisor>>1)) / divisor;
}

static inline int rescale (int x, int lold, int lnew)
{
  if(use_alternate_rescale) {
    // return x * lnew / lold;
    // returns int nearest x*(lnew-1)/(lold-1) with same parity than x
    if(x & 1) {
      return ((x * (lnew - 1) / ((lold - 1) << 1)) << 1) | 1;
    } else {
      return div_round(x * (lnew - 1), (lold - 1) << 1) << 1;
    }
  }
  else
    return div_round(x * (lnew - 1), lold - 1);
}

static void
rgb16to24 (unsigned char *to, unsigned char *from, int pixels)
{
  int i;

  for (i = 0; i < pixels; i++)
    {
      to[0] = (*(from + 1)) & 0xf8;
      to[1] = (((*(from + 1)) & 0x07) << 5) + (((*from) & 0xe0) >> 3);
      to[2] = ((*from) & 0x1f) << 3;
      to += 3;
      from += 2;
    }
}

/* only used for the *CRYPT with XVideo */
static void rgb16_to_yuyv(void *img, int size) {
  int i, *tab=(unsigned int *) img;
  static unsigned char *rgb2y=NULL,*rgb2cb,*rgb2cr;
  if(rgb2y==NULL) {
    int x;
    rgb2y=(unsigned char *) malloc(65536*sizeof(unsigned char));
    rgb2cb=(unsigned char *) malloc(65536*sizeof(unsigned char));
    rgb2cr=(unsigned char *) malloc(65536*sizeof(unsigned char));
    for(x=0; x<65536;x++) {
      int r=(x&0x001F)<<(8-5);  /* 0->255 */
      int g=(x&0x07E0)>>(11-8);
      int b=(x&0xF800)>>(16-8);
      double y =   0.2990*r + 0.5670*g + 0.1140*b; /*    0 -> 255 */
      double u = - 0.1687*r - 0.3313*g + 0.5000*b; /* -128 -> 127 */
      double v =   0.5000*r - 0.4187*g - 0.0813*b; /* -128 -> 127 */
      rgb2y[x]  = (219.0/255)*y + 16  + 0.5; /* 16->235 */
      rgb2cb[x] = (112.0/127)*u + 128 + 0.5; /* 16->240 */
      rgb2cr[x] = (112.0/127)*v + 128 + 0.5; /* 16->240 */
    }
  }
  size = size/2;
  for(i=0;i<size;i++) {
    int x=tab[i]&0xFFFF;
    int x2=(tab[i]&0xFFFF0000)>>16;
    int y1=rgb2y[x];
    int cb=rgb2cb[x];
    int cr=rgb2cr[x];
    int y2=rgb2y[x2];
    tab[i] = y1|(cr<<8)|(y2<<16)|(cb<<24);
  }
}

static void *
grab_scr2 (void *dest, int width, int height, int single, int dest_xsize)
{
  void *buf;
  int height_orig;
  int width_orig;
  int width_start;
  int offset;
  int y;
  void *dest1 = dest;
  int decodedch5;
  int secam;
  unsigned int fieldnr;
  static int burst_on = 0;

  grabbing_one=0;

  if(decode == CLEAR) {fprintf(stderr,"big pb\n"); exit(1);}
  /*
    if (debug)
      fprintf(stderr, "dest = 0x%0X\n", (unsigned int)dest);
  */
  //printf("grab_scr2: width = %d, height = %d, single = %d, dest_xsize = %d\n", width, height, single, dest_xsize);

  // there's nothing here for NTSC...
  if(cur_maxheight<576)
    return grab_scr_clear(dest,width,height,single,dest_xsize);

  if (width > 768)
    width = 768;

  height_orig = height;
  width_orig = width;
  width_start = width;

  secam = cur_secam;

  if (decode == NAGRA)
    {
      height = 288 * 2;
      if(bttvpriv) {
      if (!secam)
        {
          if (!burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_ON, NULL);
              burst_on = 1;
	    }
          width += width*BURSTOFFSET/922;
          width &= ~1;
        }
      else
        {
          if (burst_on && !forceburst)
            {
              ioctl (bttvfd, BTTV_BURST_OFF, NULL);
              burst_on = 0;
            }
        }
      }
    }
  else if ((decode > NAGRA) && (decode < NB_VIDEO_DECODER))
    {
      // xCRYPT family
      height = 288 * 2;
      width_orig = 720;
      width = 720;
      if(bttvpriv) {
      if (!secam)
        {
          if (!burst_on)
            {
              ioctl (bttvfd, BTTV_BURST_ON, NULL);
              burst_on = 1;
            }
          width += width*BURSTOFFSET/922;
          width &= ~1;
        }
      else
        {
          if (burst_on && !forceburst)
            {
              ioctl (bttvfd, BTTV_BURST_OFF, NULL);
              burst_on = 0;
            }
        }
      }
    }

#ifdef HAVE_XVID
  if(avi) {
    if(forceburst && !secam) {
      width += width*BURSTOFFSET/922;
      width &= ~1;
    }
    buf = avi_extract_frame(width,height);
    if(buf == NULL) return NULL;
  } else
#endif
  if(!v4l2) {
    gbwidth=width; gbheight=height;
    if(get_img(width,height,gbformat)==-1)
      return NULL;
    buf = map + gb_buffers.offsets[img];
  } else {
    if(gbformat2.fmt.pix.width!=width || gbformat2.fmt.pix.height!=height) {
      gbformat2.fmt.pix.width=width;
      gbformat2.fmt.pix.height=height;
      changeformat(&gbformat2);
    }
    buf = get_img2();
    if(buf == NULL) return NULL;
  }
  
#ifndef DISABLE_ALL_KIZKOOL
  if(bttvpriv) {
  if (-1 == ioctl (bttvfd, BTTV_FIELDNR, &fieldnr))
    {
      perror ("ioctl BTTV_FIELDNR");
    }
  else
    {
      CurrentFrame = fieldnr;
    }
  }
#endif


  //---------------------------------------------------------------------------
  //                      grab_scr2 : decode == NAGRA
  //--------------------------------------------------------------------------
  if (decode == NAGRA)
    {

      if (nagraudio_mode == NAGRAUDIO_AUTO)
        {
          if (!nagra_coded)
            {
              if (use_nagraudio == 1)
                set_sound_decoder (CLEAR, "Auto");
            }
          else
            {
              if (use_nagraudio == 0)
                set_sound_decoder (NAGRA, "Auto");
            }
        }
      
      if (highquality)
        {
          //printf("width_orig = %d, width = %d\n", width_orig, width);
          decode_fullframe (
                            (unsigned char *) dest,
                            (unsigned char *) buf,
                            width_orig, width, height_orig, dest_xsize);
        }
      else
        {
          //printf("width_orig = %d, width = %d\n", width_orig, width);
          decode_halfframe (
                            (unsigned char *) dest,
                            (unsigned char *) buf,
                                width_orig, width, height_orig, dest_xsize);
        }


    }
  //---------------------------------------------------------------------------
  //                       grab_scr2 : decode == xCRYPT
  //--------------------------------------------------------------------------
  else if ((decode > 1) && (decode <= 7))
    {
      static char *buf2 = NULL;
      offset = ((width - width_orig) * 2);
      decodedch5 = 1;
      //if (decoded_vcrypt (buf) >= 0 || !automode)
      if (auto_decode == DECODER_ON ||
	  (auto_decode == DECODER_AUTO && decoded_vcrypt (buf) >= 0))
        {
          switch (decode)
            {
            case SCRYPT:
              if (decodeFrame_ch5 ((unsigned char *) buf, width_orig, width)
                  == -1)
                {
                  decodeFrameVC (buf, width, 0, 10 + offset / 2);
                  decodedch5 = 0;
                }
              break;
            case KCRYPT:
              decodeFrameVCkrank (buf, width, 0, 10 + offset / 2);
              break;
            case HCRYPT:
	      //buf2 needed, otherwise segfaults with v4l2 !
	      buf2 = realloc(buf2, 778*576*2);
	      fast_memcpy(buf2, buf, width*576*2);
	      buf = buf2;
              decodeFrameVC3 (buf2, width, 0, 1);
              break;
            case XCRYPT:
              XdecodeFrameVC (buf, width, 0, 10 + offset / 2);
              break;
            default:
              decodeFrameVC (buf, width, 0, 10 + offset / 2);
            }
        }
      else
	memset(h_offset,0,288*sizeof(int));

      for(y=0; y < height_orig; y++) {
	int yy = rescale(y, height_orig, 576);
	void *buf2 = buf + offset + width * 2 * yy;
	yuv_line_to_rgb_line_ch5 (dest1, buf2, width_orig, 10, yy / 2,
				  width_start);
	dest1 += dest_xsize * 2;
      }

      if(!have_xv) {
	if (x11_native_format == VIDEO_RGB24)
	  {
	    unsigned char buf2[dest_xsize*height_orig*2];
	    fast_memcpy(buf2,dest,dest_xsize*height_orig*2);
	    rgb16to24(dest, buf2, dest_xsize*height_orig);
	  }
	else if (x11_native_format == VIDEO_RGB32)
	  {
	    unsigned char buf2[dest_xsize*height_orig*3];
	    rgb16to24(buf2, dest, dest_xsize*height_orig);
	    swap_rgb24(buf2, dest_xsize*height_orig);
	    rgb24_to_rgb32(dest, buf2, dest_xsize, height_orig);
	  }
      } else {
	/* is it really needed to translate yuv -> rgb16 -> yuv */
	rgb16_to_yuyv(dest,dest_xsize*height_orig);
      }
    }
  //---------------------------------------------------------------------------
  //                       return descrambled buffer
  //--------------------------------------------------------------------------
  return dest;
}

static int overlay2;
static int gbformat_ori, gbwidth_ori, gbheight_ori;
inline void do_after_grab_one(void) {
  if(!v4l2) {
    gbformat=gbformat_ori; gbwidth=gbwidth_ori; gbheight=gbheight_ori;
  } else {
    changeformat(&gbformat2);
    if(overlay2) video_overlay (grab_v4l2.grab_overlay);
  }
}

static void *
grab_one2 (int x11_format, int width, int height)
{
  static void *buf_ret;
  char *buf1;

  if(decode == CLEAR) {fprintf(stderr,"big pb\n"); exit(1);}

#ifdef HAVE_XVID  
  if(avi) return NULL;
#endif
  
  grabbing_one=1;

  if(cur_maxheight<576) //NTSC...
    return grab_one_clear(x11_format,width,height);

  if(x11_format < 0) x11_format = VIDEO_RGB24; // default format
  
  if(!v4l2) {
    gbformat_ori=gbformat; gbwidth_ori=gbwidth; gbheight_ori=gbheight;
    gbwidth=width; gbheight=288*2;gbformat=VIDEO_PALETTE_YUV422;
    if(get_img(gbwidth,gbheight,gbformat)==-1)
      {do_after_grab_one(); return NULL;}
    buf1 = map + gb_buffers.offsets[img];
  } else {
    struct v4l2_format gbformat2_one = gbformat2;
    gbformat2_one.fmt.pix.width = width;
    gbformat2_one.fmt.pix.height = 288*2;
    gbformat2_one.fmt.pix.pixelformat = V4L2_PIX_FMT_YUYV;
    overlay2 = overlay;
    if(overlay2) video_overlay (NULL);
    changeformat(&gbformat2_one);
    buf1 = get_img2(); 
    if(buf1==NULL) {do_after_grab_one(); return NULL;}
  }

  if(decode == NAGRA) {
    int ybar_copy;
    int ybar_auto_copy;
    int bpp_copy;
    static void *buf2 = NULL;

    ybar_copy = ybar;
    ybar_auto_copy = ybar_auto;
    ybar = 0;
    ybar_auto = 0;
    bpp_copy = bpp;
    
    if(x11_format == VIDEO_RGB16) {
      bpp = 16;
      buf2 = realloc(buf2, 2*width*height);
    }
    else if(x11_format == VIDEO_RGB32 || x11_format == VIDEO_RGB24) {
      bpp = 24;
      buf2 = realloc(buf2, 4*width*height);
    }
    else {
      do_after_grab_one();
      return NULL;
    }
    if(highquality || !nagra_coded)
      decode_fullframe_RGB ((unsigned char *) buf2, (unsigned char *) buf1, width,
			    width, height , width);
    else
      decode_halfframe_RGB ((unsigned char *) buf2, (unsigned char *) buf1, width,
			    width, height , width);
    bpp = bpp_copy;
    ybar = ybar_copy;
    ybar_auto = ybar_auto_copy;
    if(x11_format == VIDEO_RGB24) {
      static void *buf3 = NULL;
      buf3 = realloc(buf3, 3*width*height);
      rgb32_to_rgb24 (buf3, buf2, width, height);
      swap_rgb24 (buf3, width * height);
      free(buf2);
      buf2 = NULL;
      buf_ret = buf3;
    } else {
      buf_ret = buf2;
    }
  }
  else {
    do_after_grab_one();
    /* TODO !!! */
    return NULL;
  }
  do_after_grab_one();
  return buf_ret;
}


void
init_plugin (int grabber)
{
  int rc, grab_ok=0;
  if (debug)
    fprintf (stderr, "init_plugin: grabber = %d\n", grabber);
  fprintf (stderr, "\nLoading %s %s descrambling extensions.\n", PACKAGE, VERSION);
  fprintf (stderr, "It is intended for EDUCATIONAL PURPOSE only.\n\n");
  fprintf (stderr,
           "It wouldn't exist without:\n- Gerd Knorr for the original xawtv,\n");
  fprintf (stderr,
           "- Gaston, kamilh, M.Kuhn, Jens, Steffen and thebeast for the firsts xawdecodes,\n");
  fprintf (stderr,
           "Galtor's nagraudio inside with Maupatz MMX enhancement :)\n");
  fprintf (stderr, "24/32 bpp and Xvideo support by Maupatz\n");
  fprintf (stderr, "Special thanks to 1Konnu, Enek, KizKoool, Quenotte, Snabrab and Fasouil for their blue lines filters.\n");
  fprintf (stderr, "Another special thank to fl for helping me with Debian pecularities and SB16 like sound cards under Alsa.\n\n");


  if ( have_MMX == 0)
    {
      // From now on, MMX (and fast_memcpy, by the way) are  tested within xawdecode 
      // because of the new deinterlace functions
      // However we retest MMX just in case this wasn't done by xawdecode...
      if ( (have_MMX = mm_accel ()) == 0 )
        {
          fprintf (stderr, "No MMX detected: bad news: plugin deactivated!\n\n");
          return;
        }
    }
  
  grabber_sau = grabber;
  v4l = (grabbers[grabber] == &grab_v4l); grab_ok |= v4l;
  v4l2 = (grabbers[grabber] == &grab_v4l2); grab_ok |= v4l2;
#ifdef HAVE_XVID
  avi = (grabbers[grabber] == &grab_avi); grab_ok |= avi;
#endif
  if(!grab_ok) {
    fprintf(stderr, "This grabber is not compatible with this plugin\n");
    exit(1);
  }
  grab_scr_clear = grabbers[grabber]->grab_scr;
  grab_one_clear = grabbers[grabber]->grab_one;
#ifdef HAVE_XVID
  if(avi) {
    int width_capture,height_capture;
    avi_out_bytes_clear = avi_out_bytes;
    avi_out_format_clear = avi_out_format;
    video_get_capture_size(&width_capture,&height_capture);
    width_capture_clear = width_capture;
  } else
#endif
  if(!v4l2) {
    gbformat_clear = gbformat;
    pixmap_bytes_clear = pixmap_bytes;
  } else {
    pixelformat_clear = gbformat2.fmt.pix.pixelformat;
  }
  changedecode(decode);
  
  if (have_xv)
    {
      decode_fullframe = decode_fullframe_YUV;
      decode_halfframe = decode_halfframe_YUV;
    }
  else
    {
      decode_fullframe = decode_fullframe_RGB;
      decode_halfframe = decode_halfframe_RGB;
    }

  init_decode ();

  if (use_nagraudio) {
    use_nagraudio = 0; // it has not started yet
    set_sound_decoder (NAGRA, NULL);
  }

  if(bttvfd !=-1 && forceburst) {
    fprintf(stderr,"BURST FORCED\n");
    if(-1 == ioctl (bttvfd, BTTV_BURST_ON, NULL)) {
      perror("ioctl BTTV_BURST_ON");
      exit(1);
    }
    bttvpriv = 1;
  }

  if (bttvfd != -1 && !bttvpriv
      && -1 != (rc = ioctl(bttvfd, BTTV_VERSION, NULL))
      && rc >= 0x000700 && rc<0x000800)
    bttvpriv=1;
  if(bttvfd !=-1 && !bttvpriv && decode>NAGRA)
    fprintf(stderr,
	    "@@@ Your driver does not provide the BTTV_ ioctls\n"
	    "@@@ install 0.7.x bttv drivers to make *CRYPTs mode"
	    "work correctly\n");
  if(have_xv && decode>NAGRA)
    fprintf(stderr,
	    "@@@ *CRYPT implementation with XVideo is not optimized\n"
	    "@@@ you'd better to use the -noxv option\n");
}

void changedecode(int dec) {
  int i;
  int grabber = grabber_sau;
  decode = dec;
  if(decode == CLEAR) {
    grabbers[grabber]->grab_scr = grab_scr_clear;
    grabbers[grabber]->grab_one = grab_one_clear;
#ifdef HAVE_XVID
    if(avi) {
      avi_out_bytes = avi_out_bytes_clear;
      avi_out_format = avi_out_format_clear;
      return;
    }
#endif
    if(!v4l2) {
      gbformat = gbformat_clear;
      for(i=0;i<nbufs;i++) {
	gb[i].format=gbformat;
      }
      pixmap_bytes = pixmap_bytes_clear;
    } else {
      gbformat2.fmt.pix.pixelformat = pixelformat_clear;
      changeformat(&gbformat2);
    }
    if(bttvpriv && !cur_secam && !forceburst)
      ioctl (bttvfd, BTTV_BURST_OFF, NULL);
  }
  else {
    grabbers[grabber]->grab_scr = grab_scr2;
    grabbers[grabber]->grab_one = grab_one2;
    x11_pixmap_format = VIDEO_YUY2;
#ifdef HAVE_XVID
    if(avi) {
      avi_out_bytes = 2;
      avi_out_format = XVID_CSP_YUY2;
      return;
    }
#endif
    if(!v4l2) {
      gbformat = VIDEO_PALETTE_YUV422;
      for(i=0;i<nbufs;i++) {
	gb[i].format=gbformat;
      }
      pixmap_bytes = 2;
    } else {
      gbformat2.fmt.pix.pixelformat = V4L2_PIX_FMT_YUYV;
      changeformat(&gbformat2);
    }
  }
}

/* called by plugin_set_channel, cur_norm is not set yet*/
void plugin_changenorm(int norm) {
#ifdef HAVE_XVID
  if(avi && forceburst) {
    int width_capture,height_capture;
    video_get_capture_size(&width_capture,&height_capture);
    if(grabbers[grabber_sau]->issecam(norm)) {
      fprintf(stderr,"AVI BURST DISCARDED IN SECAM\n");
      video_set_capture_size(width_capture_clear,height_capture);
    } else {
      video_get_capture_size(&width_capture,&height_capture);
      width_capture = width_capture_clear/(1+BURSTOFFSET/922.0);
      width_capture &= ~1;
      if(width_capture*BURSTOFFSET/922 != width_capture_clear)
	width_capture+=2;
      fprintf(stderr,"AVI BURST IN PAL width avi->%d display->%d\n",
	      width_capture_clear,width_capture);
      video_set_capture_size(width_capture,height_capture);
    }
  }
#endif
}
