#include "vcryptkrank.h"
#include "edge.h"
#include <sys/time.h>
#include <unistd.h>
#include "ch5.h"
#include "memcpy.h"
// #include "cpoints.h"
// int h_offset[288];
// unsigned char blackline[1660*2];    // das braucht man nicht mal zu initialisieren, weil Nullen
// int color_index_left[288],color_index_right[288];
// int color_index_left2[288],color_index_right2[288];
extern int burst_phase;
extern int scryptphase;
int cptester;
int cpok;
int alter;
int cpoint;
int zeile;
//-----------------------------------------------



void
rotateFirstHalfLinekrank (unsigned char *line, int shift, int xWidth,
                          int skip)
{
  unsigned char tmp[1660];

  if (shift == 0)
    return;
  skip = 68;
  shift = shift;
  if (shift > 0)                // nach links
    {
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (skip + shift)],
              2 * (xWidth - skip - shift));
      fast_memcpy (&line[2 * (xWidth - shift)], &tmp[2 * skip], 2 * shift);
    }
  else                            // nach rechts
    {
      shift = -shift;
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (xWidth - shift)], 2 * shift);
      fast_memcpy (&line[2 * (skip + shift)], &tmp[2 * skip],
              2 * (xWidth - shift));
    }
}

//------------------------------------------------
int
findShiftkrank (unsigned char *baseline, unsigned char *line, int xWidth,
                int skip)
{
  unsigned int k, best_shift = 0, step;
  unsigned long int ls;
  long int s;
  unsigned char tbl[1660 * 2], tl[1660 * 2];
  int smax;
  int smaxfirst;
  int smaxminus;


  fast_memcpy (tbl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (tl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tl[2 * (xWidth - skip)], &line[2 * skip], 2 * (xWidth - skip));

  // TOO SLOW

  step = 2;                        // ca. 2*step^2=384-SKIP --> step=14
  ls = 0xffffffff;
  best_shift = 0;
  smax = 10;
  smaxminus = 0;
  smaxfirst = ls;
  best_shift = 303;
  for (cptester = 103; cptester <= 613; cptester += 2)
    {
      k = cptester;
      cpoint = (k * 2);
      s = line_diffkrank (tbl, &tl[(k) * 2], xWidth - skip);
      if ((s) >= smax)
        {
          best_shift = k;
          smax = s;
        }
    }
  return (best_shift);
}

//-------------------------------------------------
unsigned long int
line_diffkrank (unsigned char *bline, unsigned char *line, int width)
{
  unsigned long int s = 0;
  long int tester;
  long int tester1;
  int k;
  tester1 = 0;
  tester = 0;
  for (k = 0; k <= 6; k += 2)
    {
      tester1 += (long int) bline[cpoint - 2 - k];
      tester += (long int) bline[cpoint + k];
    }
  s = abs (tester1) - abs (tester);
  s = (s);
  return (s);
}

unsigned long int
line_diff_origkrank (unsigned char *bline, unsigned char *line, int width)
{
  unsigned long int s = 0, li, bi;
  int k;

  for (k = 0; k < width; k += 1)
    {
      bi = (unsigned long int) bline[2 * k];
      li = (unsigned long int) line[2 * k];
      s += (bi - li) * (bi - li);
    }

  return (s);
}

//-------------------------------------------------
void
decodeFrameVCkrank (unsigned char *buffer, int xBufferWidth,
                    int yBorderHeight, int skipit)
{

  int skip = 0;
  int i, j;
  int f = 1;
  if (xBufferWidth > 778)
    return;

  scryptphase = get_burst (buffer, xBufferWidth);

  skip = skipit;
  for (i = 287; i >= 0; i--)
    h_offset[i] = 0;

  for (i = 0; i < 280; i++)
    {
      zeile = i + 1;
      j =
        findShiftkrank (&buffer[2 * i * 2 * (xBufferWidth)],
                        &buffer[2 * (i + 1) * 2 * (xBufferWidth)],
                        xBufferWidth, skip);
      rotateFirstHalfLinekrank (&buffer[2 * (i + 1) * 2 * xBufferWidth], j,
                                xBufferWidth, skip);
      h_offset[i + 1] = j;
    }

  for (i = yBorderHeight; i < (288 - f - yBorderHeight); i++)
    fast_memcpy (&buffer[(2 * (i + f) + 1) * 2 * xBufferWidth],
            &buffer[(2 * (i + f)) * 2 * xBufferWidth], 2 * (xBufferWidth));


/* for(i=0;i<yBorderHeight;i++)        fast_memcpy(&buffer[2*i*2*xBufferWidth],blackline,4*xBufferWidth);
for(i=287-yBorderHeight;i<288;i++)  fast_memcpy(&buffer[2*i*2*xBufferWidth],blackline,4*xBufferWidth);*/

  make_color_index ();
}

//-----------------------------------------------
