//
//      Eine Bitte an die Programmierer. BITTE veroeffentlicht eure Sourcen!
//      Es hilft keinem wenn jeder, der eine Idee hat, das Rad neu erfinden
//      muss, nur weil er keinen vernuenftigen Source als Basis findet.
//
//      Danke an alle fuer die Vorarbeit und Tips!
//
//              nixwis
//

//
//      15.09.1999      nixwis  Farben gefaelscht. Muss man mal mit rumspielem
//                                              Sollte auch nur eine Notloesung bleiben, da die
//                                              richtige Farbe erstens besser aussieht und im
//                                              gleichen Schritt auch den CP feintunen kann
//
//      08.09.1999      nixwis  Viel ausprobiert. Die Color-Correction taugt immer
//                                              noch nichts. Korrelation etwas umgestellt, dadurch
//                                              entfaellt die Rueckwaertskorrelation
//
//      27.08.1999      nixwis  Einzel-TmpLine-Erstellung
//
//      26.08.1999      nixwis  Color correction (taugt noch nix)
//
//      23.08.1999      nixwis  Bug bei der TmpLine Generierung beseitigt.
//                                              Ich sollte den Source mal wieder aufraeumen :(
//
//      22.08.1999      nixwis  TmpLines sind jetzt YTmpLines (nur Y-Werte)
//

//
//      Todo:
//
//              FakeColor: gewuenschte Farbe dynamisch berechen, am besten
//              fuer jede Zeile einzeln
//
//              Echte Farbkorrelation
//
//              Horizontale Linien sollten die Korrelation nicht
//              zerstoeren
//

char *ver = "xcrypt.c 1999/09/15 nixwis";

#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include "ch5.h"
#include "memcpy.h"

// some macros
#define MINMAX(x,y,z) ((x)<(y)?(y):(x)>(z)?(z):(x))
#define WRAPME(x,w) ((x)>=(w)?(x)-(w):(x<0)?(x)+(w):(x))

// full decode (doesnt work yet)
//#define FULLDECODE 1

#ifdef FULLDECODE
#define LINEADDR(b,l,w) ((b)+(l)*2*(w))
#define LINES 576
#else
#define LINEADDR(b,l,w) ((b)+2*(l)*2*(w))
#define LINES 288
#endif

int h_offset[LINES];
extern int burst_phase;
extern int scryptphase;

// Prototypes (ext. functions)
unsigned int XlinediffASM (unsigned char *tmpbaseline, unsigned char *tmpline,
                           int skip, int xWidth, int shift, int step);
void make_yuyv (unsigned char *p1, int *y1, int *u, int *y2, int *v, int cp,
                int line_nr, int wo);


// Parameter
static int aktpar = 0;
static int cpstep = 8;
static int bufferfreeze = 0;
static int showfps = 0;
static int prildstep = 2;
static int secldstep = 1;
static int colorcorrect = 0;
static int colorcorrectstep = 32;
static int dodecode = 1;
static int savebuffer = 0;
static int loadbuffer = 0;
static int xoff = 0;
static int fakecolor = 7;
static int fakeu = 36;
static int fakev = 80;

// Hack fuer den freezebuffer
static unsigned char freezebuffer[2 * 880 * 576];
static int freezebuffervalid = 0;

// Prevbuffer (kommt spaeter)
#define NUMBUFFERS 1
static unsigned char prevbuffer[NUMBUFFERS][2 * 880 * 576];
static int prevoffset[NUMBUFFERS][288];
static int framecount = 0;

// Tmplines
unsigned char tbline[2 * 880];
unsigned char tline[2 * 2 * 880];

// Kram fuer die Parameter
typedef struct
{
  char *name;
  int min, max;
  int *par;
}
TXintParam;

TXintParam intParams[] = {
  {"CP step", 1, 32, &cpstep},
  {"P LD step", 1, 32, &prildstep},
  {"S LD step", 1, 32, &secldstep},
  {"CC", 0, 256, &colorcorrect},
  {"CC step", 1, 128, &colorcorrectstep},
  {"FC", 0, 16, &fakecolor},
  {"FC U", 0, 100, &fakeu},
  {"FC V", 0, 100, &fakev},
  {"IB freeze", 0, 1, &bufferfreeze},
  {"Save FB", 0, 1, &savebuffer},
  {"Load FB", 0, 1, &loadbuffer},
  {"Decode IB", 0, 1, &dodecode},
  {"XO", -100, 100, &xoff},
  {"FPS", 0, 1, &showfps},
};

void
XincInt (int *p, int min, int max)
{
  if (*p < max)
    *p = *p + 1;
}

void
XdecInt (int *p, int min, int max)
{
  if (*p > min)
    *p = *p - 1;
}

// Hack. **s muss nicht immer sinvoll sein
void
XCryptKey (char **s)
{

  if (strcmp (s[0], "Up") == 0)
    {
      if (aktpar < sizeof (intParams) / sizeof (intParams[0]) - 1)
        aktpar++;
      printf ("%s (current=%d)\n",
              intParams[aktpar].name, *(intParams[aktpar].par));
    }
  if (strcmp (s[0], "Down") == 0)
    {
      if (aktpar > 0)
        aktpar--;
      printf ("%s (current=%d)\n",
              intParams[aktpar].name, *(intParams[aktpar].par));
    }
  if (strcmp (s[0], "Left") == 0)
    {
      XdecInt (intParams[aktpar].par,
               intParams[aktpar].min, intParams[aktpar].max);
      printf ("%s is now %d\n", intParams[aktpar].name,
              *(intParams[aktpar].par));
    }
  if (strcmp (s[0], "Right") == 0)
    {
      XincInt (intParams[aktpar].par,
               intParams[aktpar].min, intParams[aktpar].max);
      printf ("%s is now %d\n", intParams[aktpar].name,
              *(intParams[aktpar].par));
    }
}

// Line shiften
void
XCutAndRotate (unsigned char *buffer,
               int lnr, int shift, int xWidth, int skip)
{
  unsigned char tmp[1660];
  unsigned char *line = LINEADDR (buffer, lnr, xWidth);

  if (shift == 0)
    return;

  // update offset
  h_offset[lnr] = WRAPME (h_offset[lnr] + shift, xWidth - skip);

  if (shift > 0)
    {
      // shift links
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (line + 2 * skip, tmp + 2 * (skip + shift),
              2 * (xWidth - skip - shift));
      fast_memcpy (line + 2 * (xWidth - shift), tmp + 2 * skip, 2 * shift);
    }
  else
    {
      // shift rechts
      shift = -shift;
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (line + 2 * skip, tmp + 2 * (xWidth - shift), 2 * shift);
      fast_memcpy (line + 2 * (skip + shift), tmp + 2 * skip,
              2 * (xWidth - shift));
    }
}

// Linediff (C-Version, Absolutwerte - zum Testen)
unsigned int
Xlinediff (unsigned char *tmpbaseline,
           unsigned char *tmpline, int skip, int xWidth, int shift, int step)
{
  int diff;
  unsigned int s;
  unsigned int k;

  s = 0;
  for (k = 0; k < xWidth - skip; k += step)
    {
      diff = tmpbaseline[k] - tmpline[k + shift];
      s += diff >= 0 ? diff : -diff;
    }

  return s;
}

// CP suchen
int
XCorrelCP (unsigned char *tmpbaseline,
           unsigned char *tmpline,
           int skip,
           int xWidth, int *shifts, int numshifts, int ldstep, int *ldout)
{
  int i, shift;
  unsigned int ld, bld;

  // FIXME in XlinediffASM!!!
  // Kann das nicht mal jemand machen? :)
  while ((xWidth - skip) % 8 != 0)
    xWidth--;

  bld = 0xFFFFFFFF;
  shift = shifts[0];
  for (i = 0; i < numshifts; i++)
    {
      //ld = Xlinediff (tmpbaseline, tmpline, skip, xWidth, shifts[i], ldstep);
      ld =
        XlinediffASM (tmpbaseline, tmpline, skip, xWidth, shifts[i], ldstep);
      if (ld < bld)
        {
          shift = shifts[i];
          bld = ld;
        }
    }
  *ldout = bld;
  return shift;
}

// TmpLine erstellen
// Nicht kritisch, aber prima MMX optimierbar
void
MakeTmpLine (unsigned char *line,
             unsigned char *tmpline, int skip, int xWidth, int dblwidth)
{
  int k;

  for (k = skip; k < xWidth; k++)
    {
      tmpline[k - skip] = line[2 * k];
    }

  if (dblwidth)
    fast_memcpy (tmpline + xWidth - skip, tmpline, xWidth - skip);
}

// UV linediff
// Damit kann man prima falsche Farben korrielieren
// und das Bild verzerren :)
unsigned int
XlinediffUV (unsigned char *baseline, unsigned char *line,
             int blcp, int lcp,
             int start, int end, int step,
             int blnr, int lnr, int xWidth, int skip)
{
  int y1bl, y2bl, ubl, vbl;
  int y1l, y2l, ul, vl;
  int wobl, wol;
  int sum;
  int tp;

  sum = 0;
  for (tp = start; tp <= end; tp += step)
    {
      wobl = tp < xWidth - skip - (h_offset[blnr] + blcp) ? 0 : 1;
      wol = tp < xWidth - skip - (h_offset[lnr] + lcp) ? 0 : 1;
//              make_yuyv (baseline+2*(skip+tp+blcp), &y1bl, &ubl, &y2bl, &vbl, h_offset[blnr]+blcp, blnr, wobl);
//              make_yuyv (line+2*(skip+tp+lcp), &y1l, &ul, &y2l, &vl, h_offset[lnr]+lcp, lnr, wol);
      make_yuyv (baseline + 2 * (skip + tp), &y1bl, &ubl, &y2bl, &vbl,
                 h_offset[blnr] + blcp, blnr, wobl);
      make_yuyv (line + 2 * (skip + tp), &y1l, &ul, &y2l, &vl,
                 h_offset[lnr] + lcp, lnr, wol);

//              sum += abs(ubl-ul)+abs(vbl-vl);
      sum +=
        (abs (ubl - ul) + abs (vbl - vl)) + (abs (y1bl - y1l) +
                                             abs (y2bl - y2l));
    }

  return sum;
}


// Shift suchen
// Vorbereitet auf ausgesuchte Shifts. Jetzt muesste
// man nur noch gute Kandidaten finden ;)
unsigned int
XFindYShift (unsigned char *buffer, int lnr, int blnr, int skip, int xWidth)
{
  unsigned char *baseline, *line;
  int ld, shift;
  int i, shifts[720];
  int numshifts;

  baseline = LINEADDR (buffer, blnr, xWidth);
  MakeTmpLine (baseline, tbline, skip, xWidth, 0);
  line = LINEADDR (buffer, lnr, xWidth);
  MakeTmpLine (line, tline, skip, xWidth, 1);
  memset (line, 128, 2 * skip);

  // grob
  numshifts = (xWidth - skip) / 2 / cpstep;
  for (i = 0; i < numshifts; i++)
    shifts[i] = 1 + 2 * cpstep * i;
  shift =
    XCorrelCP (tbline, tline, skip, xWidth, shifts, numshifts, prildstep,
               &ld);

  // fein
  if (cpstep > 1)
    {
      numshifts = 2 * cpstep + 1;
      for (i = 0; i < numshifts; i++)
        shifts[i] = WRAPME (shift - 2 * cpstep + 2 * i, xWidth - skip);
      shift =
        XCorrelCP (tbline, tline, skip, xWidth, shifts, numshifts, secldstep,
                   &ld);
    }

  return shift;

}

// Farbkorrelation
//
// Da muss noch viel gebastelt werden
// Problem: wenn man mal falsch liegt bekommt
// man ein prima hin- und hergeshifte. 
int
XFindColorShift (unsigned char *buffer,
                 int blnr, int lnr,
                 int crange,
                 int start, int end, int step, int skip, int xWidth)
{
  int k, bk;
  int ld, bld;
  unsigned char *line, *baseline;

  line = LINEADDR (buffer, lnr, xWidth);
  baseline = LINEADDR (buffer, blnr, xWidth);

  bk = 0;
  bld = 0xfffffff;
  for (k = -2 * crange; k <= 2 * crange; k += 2)
    {
      ld =
        XlinediffUV (baseline, line, 0, k, start, end, step, blnr, lnr,
                     xWidth, skip);
      if (ld < bld)
        {
          bld = ld;
          bk = k;
        }
    }

  return bk;
}

// Farbe korrigierung und CP feintunen
// Waere schoen wenn das mal klappen sollte
void
XCorrectColor (unsigned char *buffer, int xWidth, int yBorderHeight, int skip)
{
  int i, shift;
  int crange = 2 * colorcorrect;
  int cstep = 2 * colorcorrectstep;

  for (i = yBorderHeight; i < LINES - yBorderHeight - 1; i++)
    {
      shift =
        XFindColorShift (buffer, i, i + 1, crange, crange,
                         xWidth - skip - 1 - crange, cstep, skip, xWidth);
      XCutAndRotate (buffer, i + 1, shift, xWidth, skip);
    }
}

// Farbe faken
// Dies soll keine endgueltige Kapitulation vor
// der echten Farbkorrelation werden
void
XFakeColor (unsigned char *buffer, int xWidth, int yBorderHeight, int skip)
{
  int i, j, k, bk;
  unsigned int d, bd;
  int u, v, y1, y2, lu, lv;
  int mu, mv;
  unsigned char *line;
  int step = 64;
  int minuv = 0;

  mu = fakeu * 25;
  mv = fakev * 25;


  for (i = yBorderHeight; i < LINES - yBorderHeight; i++)
    {

      bk = 0;
      bd = 0xFFFFFFFF;
      line = LINEADDR (buffer, i, xWidth);

      for (k = -2 * fakecolor; k <= 2 * fakecolor; k += 2)
        {

          lu = lv = 0;
          for (j = 32; j < xWidth - skip - 32; j += step)
            {
              make_yuyv (line + 2 * (skip + j), &y1, &u, &y2, &v,
                         h_offset[i] + k, i,
                         j < xWidth - skip - h_offset[i] - k ? 0 : 1);
              if (abs (u - 128) > minuv || abs (v - 128) > minuv)
                {
                  lu += u;
                  lv += v;
                }
            }

          d = (mu - lu) * (mu - lu) + (mv - lv) * (mv - lv);
          if (d < bd)
            {
              bd = d;
              bk = k;
            }

        }

      // fake offset but don't shift
      h_offset[i] = WRAPME (h_offset[i] + bk, xWidth - skip);

    }

}

// Frame dekodieren (zumindest versuche :))
void
XDecodeFrame (unsigned char *buffer, int xWidth, int yBorderHeight, int skip)
{
  int i, br, r, k, bk;
  int precorrect[LINES];
  int shift;

  // Precorrect ruecksetzen
  for (i = 0; i < LINES; i++)
    precorrect[i] = 0;

  // Volle Korrelation, precorrects merken
  for (i = yBorderHeight; i < LINES - 1 - yBorderHeight; i++)
    {
      shift = XFindYShift (buffer, i + 1, i, skip, xWidth);
      if (shift < 103)
        {
          precorrect[i + 1] = 103 - shift;
          shift = 103;
        }
      if (shift > 613)
        {
          precorrect[i + 1] = 613 - shift;
          shift = 613;
        }
      XCutAndRotate (buffer, i + 1, shift, xWidth, skip);
    }

  // Precorrects anwenden
  r = 0;
  for (i = LINES - 1 - yBorderHeight; i >= yBorderHeight; i--)
    {
      XCutAndRotate (buffer, i, r, xWidth, skip);
      r = WRAPME (r + precorrect[i], xWidth - skip);
    }

  // Rand Offset finden (brute force)
  bk = br = 0;
  for (r = 0; r < xWidth - skip; r += 2)
    {
      k = 0;
      for (i = yBorderHeight + 1; i <= LINES - 1 - yBorderHeight; i++)
        {
          shift = WRAPME (h_offset[i] + r, xWidth - skip);
          if (shift >= 103 && shift <= 613)
            k++;
        }
      if (k > bk)
        {
          bk = k;
          br = r;
        }
    }

  // Rand Offset korrigieren
  for (i = yBorderHeight; i <= LINES - 1 - yBorderHeight; i++)
    {
      XCutAndRotate (buffer, i, br + xoff, xWidth, skip);
    }

  // Color (Fake- und normale Korrekur schliessen sich normalerweise aus)
  if (fakecolor)
    XFakeColor (buffer, xWidth, yBorderHeight, skip);
  if (colorcorrect)
    XCorrectColor (buffer, xWidth, yBorderHeight, skip);


}

// Hier gehts los
void
XdecodeFrameVC (unsigned char *buffer,
                int xBufferWidth, int yBorderHeight, int skipit)
{

  FILE *filep;
  char fname[1024];
  struct timeval t1, t2;
  double elapsed;
  int skip;
  int i;

  if (xBufferWidth > 880)
    return;

  // skip
  skip = skipit;

  // reset offsets
  for (i = 0; i < LINES; i++)
    h_offset[i] = 0;

  // buffer load & save (alles hacked, sorry)
  if (savebuffer && bufferfreeze && freezebuffervalid)
    {
      printf ("Save buffer to: ");
      fgets (fname, sizeof (fname), stdin);
      fname[strlen (fname) - 1] = 0;
      strcat (fname, ".freezebuffer");
      filep = fopen (fname, "w");
      if (filep)
        {
          fwrite (freezebuffer, sizeof (freezebuffer), 1, filep);
          fclose (filep);
          puts ("Saved!");
        }
      else
        {
          puts ("Failed!");
        }
      savebuffer = 0;
    }
  if (loadbuffer)
    {
      printf ("Load buffer from: ");
      fgets (fname, sizeof (fname), stdin);
      fname[strlen (fname) - 1] = 0;
      strcat (fname, ".freezebuffer");
      filep = fopen (fname, "r");
      if (filep)
        {
          fread (freezebuffer, sizeof (freezebuffer), 1, filep);
          fclose (filep);
          puts ("Loaded!");
        }
      else
        {
          puts ("Failed!");
        }
      loadbuffer = 0;
      bufferfreeze = 1;
      freezebuffervalid = 1;
    }

  // freeze buffer
  if (bufferfreeze)
    {
      if (!freezebuffervalid)
        {
          fast_memcpy (freezebuffer, buffer, 2 * 576 * xBufferWidth);
          freezebuffervalid = 1;
        }
      fast_memcpy (buffer, freezebuffer, 2 * 576 * xBufferWidth);
    }
  else
    {
      if (freezebuffervalid)
        {
          freezebuffervalid = 0;
        }
    }

  // Phase merken
  scryptphase = get_burst (buffer, xBufferWidth);

  // Stopuhr start
  gettimeofday (&t1, 0);

  // Dekodierung
  if (dodecode)
    XDecodeFrame (buffer, xBufferWidth, yBorderHeight, skip);

  // Stopuhr stop
  gettimeofday (&t2, 0);
  elapsed =
    (t2.tv_sec + t2.tv_usec / 1.0e6) - (t1.tv_sec + t1.tv_usec / 1.0e6);

  // Show FPS
  if (showfps)
    {
      printf ("vc_decode_time: %.3f  vc_decode_fps: %.3f\n", elapsed,
              1 / elapsed);
    }

#ifndef FULLDECODE
  // Copy lines
  for (i = yBorderHeight; i < (LINES - yBorderHeight); i++)
    fast_memcpy (&buffer[(2 * i + 1) * 2 * xBufferWidth],
            &buffer[(2 * i) * 2 * xBufferWidth], 2 * xBufferWidth);
#endif

  // Index fuer die Farbe
  make_color_index ();

  // Save buffer
  fast_memcpy (prevbuffer[framecount % NUMBUFFERS], buffer,
          2 * 576 * xBufferWidth);
  for (i = 0; i < 288; i++)
    {
      prevoffset[framecount % NUMBUFFERS][i] = h_offset[i];
    }

  framecount++;

}

//
// vim:tabstop=4:nowrap
//
